; Assemblerquelltext des RONPAS-Compilers (c) by Ronald Daleske
; PROGRAM-NAME: TXTVGA2.PAS
 
.nolist
.INCLUDE "m328Pdef.inc"
.list
 
; *** Konstantentabelle ***
 
.equ        CTC_WERT  =  0x02FA ; WORD
.equ        LAENGE_BWS  =  0x07B3 ; WORD
.equ        ANZAHL_SPALTEN  =  0x0044 ; WORD
.equ        LAENGE_VLINE_ARRAY  =  0x01FD ; WORD
.equ        ITP3_WHO_AM_I  =  0x01 ; BYTE
.equ        ITP3_ERROR_CODE  =  0x02 ; BYTE
.equ        ITP3_CONOUT  =  0x03 ; BYTE
.equ        ITP3_CONST  =  0x04 ; BYTE
.equ        ITP3_CONIN  =  0x05 ; BYTE
 
; *** Variablentabelle ***
 
.dseg
 
DBG_ANFANG_VAR_TABELLE:
 
WERT_YL:   ; Byte
.byte     1
WERT_YH:   ; Byte
.byte     1
WERT_ZH:   ; Byte
.byte     1
WERT_BWS_H:   ; Byte
.byte     1
WERT_BWS_L:   ; Byte
.byte     1
FUELLBYTE:   ; Byte
.byte     1
BWS_POS:   ; Word
.byte     2
WRITE_STRING:   ; String(20)
.byte     1     ; STRING-Laenge
.byte     20
ESC_SEQUENZ_FOLGT:   ; Boolean
.byte     1
CURSOR_IS_ON:   ; Boolean
.byte     1
CURSOR_BYTE:   ; Byte
.byte     1
CURSOR_COUNTER:   ; Word
.byte     2
 
BWS:
.byte     1972
 
 
 
; *** Codesegment ***
.cseg
 
; *** Sprungtabelle ***
.ORG 0
 
; Sprung in das Hauptprogramm
        JMP       RESET
 
; Timer/Counter1 Compare Match A
.ORG OC1Aaddr
        JMP        TIMER1_COMPA
 
; PROCEDURE - Anfang (TIMER0_AUS)
TIMER0_AUS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR0A)
        OUT        TCCR0A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR0B)
        OUT        TCCR0B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TIMSK0)
        STS        TIMSK0, R16
 
; PROCEDURE - Ende (TIMER0_AUS)
        RET
 
; PROCEDURE - Anfang (INIT_TIMER0_OVF)
INIT_TIMER0_OVF:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR0A)
        OUT        TCCR0A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x04)
        LDI        R16, 0x04
 
; Zuweisung Ziel /  VAR (TCCR0B)
        OUT        TCCR0B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (TIMSK0)
        STS        TIMSK0, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TIFR0)
        OUT        TIFR0, R16
 
; PROCEDURE - Ende (INIT_TIMER0_OVF)
        RET
 
; PROCEDURE - Anfang (TIMER1_AUS)
TIMER1_AUS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR1A)
        STS        TCCR1A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR1B)
        STS        TCCR1B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TIMSK1)
        STS        TIMSK1, R16
 
; PROCEDURE - Ende (TIMER1_AUS)
        RET
 
; PROCEDURE - Anfang (INIT_TIMER1_COMPA)
INIT_TIMER1_COMPA:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x09)
        LDI        R16, 0x09
 
; Zuweisung Ziel /  VAR (TCCR1B)
        STS        TCCR1B, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Hight(WERT)
        MOV        R16, R1
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B_WERT_H)
        MOV        R3, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung Low(WERT)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B_WERT_L)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B_WERT_H)
        MOV        R16, R3
 
; Zuweisung Ziel /  VAR (OCR1AH)
        STS        OCR1AH, R16
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B_WERT_L)
        MOV        R16, R2
 
; Zuweisung Ziel /  VAR (OCR1AL)
        STS        OCR1AL, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x02)
        LDI        R16, 0x02
 
; Zuweisung Ziel /  VAR (TIMSK1)
        STS        TIMSK1, R16
 
; PROCEDURE - Ende (INIT_TIMER1_COMPA)
        RET
 
; PROCEDURE - Anfang (INIT_TIMER1_OVF)
INIT_TIMER1_OVF:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR1A)
        STS        TCCR1A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x05)
        LDI        R16, 0x05
 
; Zuweisung Ziel /  VAR (TCCR1B)
        STS        TCCR1B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (ASSR)
        STS        ASSR, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (TIMSK2)
        STS        TIMSK2, R16
 
; PROCEDURE - Ende (INIT_TIMER1_OVF)
        RET
 
; PROCEDURE - Anfang (INIT_TIMER2_OVF)
INIT_TIMER2_OVF:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (TCCR2A)
        STS        TCCR2A, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x05)
        LDI        R16, 0x05
 
; Zuweisung Ziel /  VAR (TCCR2B)
        STS        TCCR2B, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (ASSR)
        STS        ASSR, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  VAR (TIMSK2)
        STS        TIMSK2, R16
 
; PROCEDURE - Ende (INIT_TIMER2_OVF)
        RET
 
; PROCEDURE - Anfang (INITPORTS)
INITPORTS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x1F)
        LDI        R16, 0x1F
 
; Zuweisung Ziel /  VAR (DDRB)
        OUT        DDRB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTB)
        OUT        PORTB, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTC)
        OUT        PORTC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (DDRC)
        OUT        DDRC, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (PORTD)
        OUT        PORTD, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (DDRD)
        OUT        DDRD, R16
 
; PROCEDURE - Ende (INITPORTS)
        RET
 
; ISR - Einsprung
TIMER1_COMPA:
        PUSH       R16
        IN         R16,SREG
        PUSH       R16
 
; ASM
; Verwaltung der Ports
; ---------------------

.equ 	port_control_b	= portb
.equ 	port_daten	= portd



; *** port_control_b ***

.equ 	VSYNC		= 0		;// Vertikale Synchronimpulse Pin 14
.equ 	HSYNC		= 1		;// Horizontale Synchronimpulse Pin 15
.equ	b_LED_GN	= 2		;// b_LED_GN -> gruene LED  Pin 16
.equ 	b_CE_CLK	= 3		;// /b_CI fuer 74HC165 - CLock Inhibit / Taktsperre Pin 17
.equ 	b_SL		= 4		;// /b_SL fuer 74HC165 - Shift / Load - Schieben / Laden Pin 18



; VERTICAL LINE CONTROL
.equ 	VL_RESET	= 0
.equ 	VL_VER_IMP	= 1
.equ 	VL_OUT_VA	= 2
.equ 	VL_BWS          = 3


	lds	R16,tcnt1l
	cpi	R16,13
	brlo	LATFIX1

LATFIX1:
	cpi	R16,14
	brlo	LATFIX2

LATFIX2:
	cpi	R16,15
	brlo	LATFIX3

LATFIX3:
	cpi	R16,16
	brlo	LATFIX4

LATFIX4:



	push	R17
	push	R18

	push	zl
	push	zh
	push	yl
	push	yh


	lds	yl, Wert_yl
	lds	yh, Wert_yh




; HORIZONTAL SYNC LOW
	cbi	port_control_b, HSYNC




; SET POINTER TO VLINE TABLE
	ldi	zl,low(2*VLINE)
	ldi	zh,high(2*VLINE)



; SET VLINE TABLE POSITION
	add	zl,yl
	adc	zh,yh


; READ VLINE TABLE BYTE
	lpm	R16,z



; INCREMENT VLINE COUNTER
	adiw	yh:yl,1				



; RESET VLINE COUNTER
	sbrc	R16,VL_RESET			
	clr	yl
	sbrc	R16,VL_RESET			
	clr	yh


	sts	Wert_yl, yl
	sts	Wert_yh, yh


; VERTICAL SYNC CONTROL
	sbrc	R16, VL_VER_IMP	
	cbi	port_control_b, VSYNC
	sbrs	R16, VL_VER_IMP		
	sbi	port_control_b, VSYNC


; HORIZONTAL SYNC HIGH
	sbi	port_control_b, HSYNC


        lds	yl, Wert_BWS_L
        lds	yh, Wert_BWS_H


; BWS auf Anfang setzen
	sbrs	R16,VL_BWS
        rjmp	BWS_weiter

	ldi	yl, low(BWS)
	ldi	yh, high(BWS)

        sts     Wert_BWS_L, yl
        sts     Wert_BWS_H, yh

BWS_weiter:


; CONTROL ACTIVE LINES
	sbrs	R16,VL_OUT_VA
	rjmp	NOVID


; -----------------------------------------------
; ab hier wird eine Bildschirmzeile ausgegeben
; -----------------------------------------------

        lds	zh, Wert_zh

	in      R17, port_control_b      ;// 1
	cbr	R17, 0b00011000          ;// 1
        mov     R18, R17                 ;// 1 - R17 -> R18
        sbr     R18, 0b00010000          ;// 1
        ;// R17 -> /CE_CLK (3) aktiv, ShiftLoad (4) auf 0 -> Load
        ;// R18 -> /CE_CLK (3) aktiv, ShiftLoad (4) auf 1 -> Shift


	ldi	R16, 0xFF               ; 1
	out	port_daten, R16         ; 1


; *** 0..7 ***

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3

        ; als linker Rand wird erst kurz das
        ; 0xFF-Byte ausgegeben, damit das erste Zeichen
        ; einen kleinen Abstand vom linken Rand hat ...
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

        ; ... dann folgt das erste Zeichen
	out	port_daten, R16	        ; Low Nibble ausgeben	1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1




; *** 8..15 ***

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1





; *** 16..23 ***

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1



; *** 24..31 ***

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1




; *** 32..39 ***

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1




; *** 40..47 ***

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1




; *** 48..55 ***

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1




; *** 56..63 ***

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


; *** 64..67 ***


	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

       	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

	ld	ZL, y+			; ASCII aus RAM lesen	2
	lpm	R16, Z			; Byte aus CGROM lesen	3
	out	port_daten, R16	        ; Low Nibble ausgeben	1
        nop;
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1



;// *** nach 60 Zeichen ***



        nop                             ; 1
        nop                             ; 1
        nop                             ; 1
        nop                             ; 1


	ldi	R16, 0xFF               ; 1
	out	port_daten, R16         ; 1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1

	ldi	R16, 0x00               ; 1
	out	port_daten, R16         ; 1
	out	port_control_b, R17     ; 1
        out	port_control_b, R18     ; 1


	sbi	port_control_b, b_CE_CLK



        inc     zh
        cpi     zh, 32

	brne    video_zh

	ldi	zh,16
        sts     Wert_BWS_L, yl
        sts     Wert_BWS_H, yh

video_zh:


       	sts	Wert_zh, zh



; -----------------------------------------------





; BLANKING LINES EXIT POINT
NOVID:


	pop	yh
	pop	yl
	pop	zh
	pop	zl


	pop	r18
	pop	r17


 
 
; ISR - Ende
        POP        R16
        OUT        SREG,R16
        POP        R16
        RETI
 
; PROCEDURE - Anfang (SWITCH_CURSOR_ON)
SWITCH_CURSOR_ON:
 
; ARRAY - Ausdruck / Word-VAR (BWS_POS)
        LDS        R16, BWS_POS
        LDS        R17, BWS_POS+1
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (BWS)
        LDI        ZL, LOW(BWS)
        LDI        ZH, HIGH(BWS)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  VAR (CURSOR_BYTE)
        STS        CURSOR_BYTE, R16
 
; VAR ARRAY POSITION - Ausdruck / Word-VAR (BWS_POS)
        LDS        R16, BWS_POS
        LDS        R17, BWS_POS+1
 
; VAR ARRAY Ziel Zeiger berechnen (BWS)
        LDI        ZL, LOW(BWS)
        LDI        ZH, HIGH(BWS)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x5F)
        LDI        R16, 0x5F
 
; Zuweisung Ziel /  VAR ARRAY (BWS)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (CURSOR_IS_ON)
        STS        CURSOR_IS_ON, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CURSOR_COUNTER)
        STS        CURSOR_COUNTER, R16
        STS        CURSOR_COUNTER+1, R17
 
; PROCEDURE - Ende (SWITCH_CURSOR_ON)
        RET
 
; PROCEDURE - Anfang (SWITCH_CURSOR_OFF)
SWITCH_CURSOR_OFF:
 
; VAR ARRAY POSITION - Ausdruck / Word-VAR (BWS_POS)
        LDS        R16, BWS_POS
        LDS        R17, BWS_POS+1
 
; VAR ARRAY Ziel Zeiger berechnen (BWS)
        LDI        ZL, LOW(BWS)
        LDI        ZH, HIGH(BWS)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (CURSOR_BYTE)
        LDS        R16, CURSOR_BYTE
 
; Zuweisung Ziel /  VAR ARRAY (BWS)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CURSOR_IS_ON)
        STS        CURSOR_IS_ON, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CURSOR_COUNTER)
        STS        CURSOR_COUNTER, R16
        STS        CURSOR_COUNTER+1, R17
 
; PROCEDURE - Ende (SWITCH_CURSOR_OFF)
        RET
 
; PROCEDURE - Anfang (SWITCH_CURSOR)
SWITCH_CURSOR:
 
; IF THEN - Ausdruck / Byte-VAR (CURSOR_IS_ON)
        LDS        R16, CURSOR_IS_ON
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_01
        RJMP       M_IF_02
M_IF_01:
 
; Aufruf PROCEDURE (SWITCH_CURSOR_OFF)
        CALL       SWITCH_CURSOR_OFF
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_03
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_02:
 
; Aufruf PROCEDURE (SWITCH_CURSOR_ON)
        CALL       SWITCH_CURSOR_ON
 
; IF_THEN_ELSE - Ende
M_IF_03:
 
; PROCEDURE - Ende (SWITCH_CURSOR)
        RET
 
; PROCEDURE - Anfang (SCHREIBE_ZEICHEN_IN_BWS)
SCHREIBE_ZEICHEN_IN_BWS:
 
; VAR ARRAY POSITION - Ausdruck / Word-VAR (BWS_POS)
        LDS        R16, BWS_POS
        LDS        R17, BWS_POS+1
 
; VAR ARRAY Ziel Zeiger berechnen (BWS)
        LDI        ZL, LOW(BWS)
        LDI        ZH, HIGH(BWS)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokaler Uebergabeparameter (DAS_BYTE)
        MOV        R16, R0
 
; Zuweisung Ziel /  VAR ARRAY (BWS)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (BWS_POS)
        LDS        R16, BWS_POS
        LDS        R17, BWS_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / Konstante CONST (LAENGE_BWS)
        LDI        R18, LOW(0x07B3)
        LDI        R19, HIGH(0x07B3)
 
; Operator <
        CP         R16, R18
        CPC        R17, R19
        BRCS       M_VERGL_07
        CLR        R16
        RJMP       M_VERGL_08
M_VERGL_07:
        SER        R16
M_VERGL_08:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_04
        RJMP       M_IF_05
M_IF_04:
 
; INC(BWS_POS) - Word
        LDS        R24, BWS_POS
        LDS        R25, BWS_POS+1
        ADIW       R25:R24, 1
        STS        BWS_POS, R24
        STS        BWS_POS+1, R25
 
; IF_THEN - Ende
M_IF_05:
 
; PROCEDURE - Ende (SCHREIBE_ZEICHEN_IN_BWS)
        RET
 
; PROCEDURE - Anfang (SCREEN_ROLL_UP)
SCREEN_ROLL_UP:
 
; Zuweisung Quelle - Ausdruck / Konstante CONST (ANZAHL_SPALTEN)
        LDI        R16, LOW(0x0044)
        LDI        R17, HIGH(0x0044)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W2)
        MOV        R2, R16
        MOV        R3, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / Konstante CONST (LAENGE_BWS)
        LDI        R16, LOW(0x07B3)
        LDI        R17, HIGH(0x07B3)
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (ANZAHL_SPALTEN)
        LDI        R18, LOW(0x0044)
        LDI        R19, HIGH(0x0044)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W3)
        MOV        R4, R16
        MOV        R5, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (W3)
        MOV        R16, R4
        MOV        R17, R5
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_09:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_010
        RJMP       M_FTD_011
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_010:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (W2)
        MOV        R16, R2
        MOV        R17, R3
 
; Zuweisung Quelle - Ausdruck /; VAR ARRAY (BWS)
        LDI        ZL, LOW(BWS)
        LDI        ZH, HIGH(BWS)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R6, R16
 
; VAR ARRAY POSITION - Ausdruck / lokale, dynamische Variable VAR (W1)
        MOV        R16, R0
        MOV        R17, R1
 
; VAR ARRAY Ziel Zeiger berechnen (BWS)
        LDI        ZL, LOW(BWS)
        LDI        ZH, HIGH(BWS)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R6
 
; Zuweisung Ziel /  VAR ARRAY (BWS)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; INC(W2) - Word
        MOV        R24, R2
        MOV        R25, R3
        ADIW       R25:R24, 1
        MOV        R2, R24
        MOV        R3, R25
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_09
 
; FOR TO DO - Ende
M_FTD_011:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; INC(W3) - Word
        MOV        R24, R4
        MOV        R25, R5
        ADIW       R25:R24, 1
        MOV        R4, R24
        MOV        R5, R25
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W3)
        MOV        R16, R4
        MOV        R17, R5
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0001)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Konstante CONST (LAENGE_BWS)
        LDI        R16, LOW(0x07B3)
        LDI        R17, HIGH(0x07B3)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_012:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_013
        RJMP       M_FTD_014
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_013:
 
; VAR ARRAY POSITION - Ausdruck / lokale, dynamische Variable VAR (W1)
        MOV        R16, R0
        MOV        R17, R1
 
; VAR ARRAY Ziel Zeiger berechnen (BWS)
        LDI        ZL, LOW(BWS)
        LDI        ZH, HIGH(BWS)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (FUELLBYTE)
        LDS        R16, FUELLBYTE
 
; Zuweisung Ziel /  VAR ARRAY (BWS)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_012
 
; FOR TO DO - Ende
M_FTD_014:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (SCREEN_ROLL_UP)
        RET
 
; PROCEDURE - Anfang (BERECHNE_LF)
BERECHNE_LF:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Konstante CONST (LAENGE_BWS)
        LDI        R16, LOW(0x07B3)
        LDI        R17, HIGH(0x07B3)
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (ANZAHL_SPALTEN)
        LDI        R18, LOW(0x0044)
        LDI        R19, HIGH(0x0044)
 
; Operator -
        SUB        R16, R18
        SBC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W1)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0001)
        LDI        R18, LOW(0x0001)
        LDI        R19, HIGH(0x0001)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R0, R16
        MOV        R1, R17
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (BWS_POS)
        LDS        R16, BWS_POS
        LDS        R17, BWS_POS+1
 
; IF THEN - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (W1)
        MOV        R18, R0
        MOV        R19, R1
 
; Operator <
        CP         R16, R18
        CPC        R17, R19
        BRCS       M_VERGL_018
        CLR        R16
        RJMP       M_VERGL_019
M_VERGL_018:
        SER        R16
M_VERGL_019:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_015
        RJMP       M_IF_016
M_IF_015:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (BWS_POS)
        LDS        R16, BWS_POS
        LDS        R17, BWS_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (ANZAHL_SPALTEN)
        LDI        R18, LOW(0x0044)
        LDI        R19, HIGH(0x0044)
 
; Operator +
        ADD        R16, R18
        ADC        R17, R19
 
; Zuweisung Ziel /  VAR (BWS_POS)
        STS        BWS_POS, R16
        STS        BWS_POS+1, R17
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_017
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_016:
 
; Retten der lokalen Parameter fuer PROCEDURE (BERECHNE_LF)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (SCREEN_ROLL_UP)
        CALL       SCREEN_ROLL_UP
 
; Retten der Parameter-Register fuer PROCEDURE (BERECHNE_LF)
        POP        R1
        POP        R0
 
; Zuweisung Quelle - Ausdruck / lokale, dynamische Variable VAR (W1)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Ziel /  VAR (BWS_POS)
        STS        BWS_POS, R16
        STS        BWS_POS+1, R17
 
; IF_THEN_ELSE - Ende
M_IF_017:
 
; PROCEDURE - Ende (BERECHNE_LF)
        RET
 
; PROCEDURE - Anfang (LOESCHE_BWS)
LOESCHE_BWS:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZEICHEN_ZAEHLER)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Konstante CONST (LAENGE_BWS)
        LDI        R16, LOW(0x07B3)
        LDI        R17, HIGH(0x07B3)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_020:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_021
        RJMP       M_FTD_022
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_021:
 
; VAR ARRAY POSITION - Ausdruck / lokale, dynamische Variable VAR (ZEICHEN_ZAEHLER)
        MOV        R16, R0
        MOV        R17, R1
 
; VAR ARRAY Ziel Zeiger berechnen (BWS)
        LDI        ZL, LOW(BWS)
        LDI        ZH, HIGH(BWS)
        ADD        ZL, R16
        ADC        ZH, R17
        PUSH       ZL
        PUSH       ZH
 
; Zuweisung Quelle - Ausdruck / Byte-VAR (FUELLBYTE)
        LDS        R16, FUELLBYTE
 
; Zuweisung Ziel /  VAR ARRAY (BWS)
        POP        ZH
        POP        ZL
        ST         Z, R16
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_020
 
; FOR TO DO - Ende
M_FTD_022:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (BWS_POS)
        STS        BWS_POS, R16
        STS        BWS_POS+1, R17
 
; PROCEDURE - Ende (LOESCHE_BWS)
        RET
 
; PROCEDURE - Anfang (BERECHNE_CR)
BERECHNE_CR:
 
; Zuweisung Quelle - Ausdruck erster Faktor / Word-VAR (BWS_POS)
        LDS        R16, BWS_POS
        LDS        R17, BWS_POS+1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (ANZAHL_SPALTEN)
        LDI        R18, LOW(0x0044)
        LDI        R19, HIGH(0x0044)
 
; Operator DIV
        CALL       ASM_UP_MDIV16
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (W1)
        MOV        R0, R16
        MOV        R1, R17
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (W1)
        MOV        R16, R0
        MOV        R17, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Konstante CONST (ANZAHL_SPALTEN)
        LDI        R18, LOW(0x0044)
        LDI        R19, HIGH(0x0044)
 
; Operator *
        CALL       ASM_UP_MUL16
 
; Zuweisung Ziel /  VAR (BWS_POS)
        STS        BWS_POS, R16
        STS        BWS_POS+1, R17
 
; PROCEDURE - Ende (BERECHNE_CR)
        RET
 
; PROCEDURE - Anfang (SCHREIBE_BYTE_IN_BWS)
SCHREIBE_BYTE_IN_BWS:
 
; IF THEN - Ausdruck / Byte-VAR (CURSOR_IS_ON)
        LDS        R16, CURSOR_IS_ON
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_023
        RJMP       M_IF_024
M_IF_023:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        PUSH       R0
 
; Aufruf PROCEDURE (SWITCH_CURSOR_OFF)
        CALL       SWITCH_CURSOR_OFF
 
; Retten der Parameter-Register fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        POP        R0
 
; IF_THEN - Ende
M_IF_024:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CURSOR_COUNTER)
        STS        CURSOR_COUNTER, R16
        STS        CURSOR_COUNTER+1, R17
 
; IF THEN - Ausdruck / Byte-VAR (ESC_SEQUENZ_FOLGT)
        LDS        R16, ESC_SEQUENZ_FOLGT
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_026
        RJMP       M_IF_027
M_IF_026:
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_028
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_027:
 
; CASE OF - lokaler Uebergabeparameter (DAS_BYTE)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element ($0A)
        CPI        R16, 0x0A
        BREQ       M_CASE_031
        RJMP       M_CASE_030
M_CASE_031:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        PUSH       R0
 
; Aufruf PROCEDURE (BERECHNE_LF)
        CALL       BERECHNE_LF
 
; Retten der Parameter-Register fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_029
M_CASE_030:
 
; CASE OF - vergleiche Einzel-Element ($0C)
        CPI        R16, 0x0C
        BREQ       M_CASE_033
        RJMP       M_CASE_032
M_CASE_033:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        PUSH       R0
 
; Aufruf PROCEDURE (LOESCHE_BWS)
        CALL       LOESCHE_BWS
 
; Retten der Parameter-Register fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_029
M_CASE_032:
 
; CASE OF - vergleiche Einzel-Element ($0D)
        CPI        R16, 0x0D
        BREQ       M_CASE_035
        RJMP       M_CASE_034
M_CASE_035:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        PUSH       R0
 
; Aufruf PROCEDURE (BERECHNE_CR)
        CALL       BERECHNE_CR
 
; Retten der Parameter-Register fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_029
M_CASE_034:
 
; CASE OF - vergleiche Einzel-Element ($1B)
        CPI        R16, 0x1B
        BREQ       M_CASE_037
        RJMP       M_CASE_036
M_CASE_037:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0xFF)
        LDI        R16, 0xFF
 
; Zuweisung Ziel /  VAR (ESC_SEQUENZ_FOLGT)
        STS        ESC_SEQUENZ_FOLGT, R16
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_029
M_CASE_036:
 
; CASE OF - vergleiche Byte-Element-Bereich <von> ($20)
        CPI        R16, 0x20
        BRCC       M_CASE_040
        RJMP       M_CASE_038
M_CASE_040:
 
; CASE OF - vergleiche Byte-Element-Bereich <bis> ($7F)
        LDI        R17, 0x7F
        CP         R17, R16
        BRCC       M_CASE_039
        RJMP       M_CASE_038
M_CASE_039:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        PUSH       R0
 
; Aufruf PROCEDURE (SCHREIBE_ZEICHEN_IN_BWS)
        CALL       SCHREIBE_ZEICHEN_IN_BWS
 
; Retten der Parameter-Register fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_029
 
; CASE OF ELSE
M_CASE_038:
 
; Retten der lokalen Parameter fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        PUSH       R0
 
; Byte-Parameter(1) fuer PROCEDURE (SCHREIBE_ZEICHEN_IN_BWS)
        LDI        R16, 0x3C
        MOV        R0, R16
 
; Aufruf PROCEDURE (SCHREIBE_ZEICHEN_IN_BWS)
        CALL       SCHREIBE_ZEICHEN_IN_BWS
 
; Retten der Parameter-Register fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        PUSH       R0
 
; Aufruf PROCEDURE (SCHREIBE_ZEICHEN_IN_BWS)
        CALL       SCHREIBE_ZEICHEN_IN_BWS
 
; Retten der Parameter-Register fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        POP        R0
 
; Retten der lokalen Parameter fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        PUSH       R0
 
; Byte-Parameter(1) fuer PROCEDURE (SCHREIBE_ZEICHEN_IN_BWS)
        LDI        R16, 0x3E
        MOV        R0, R16
 
; Aufruf PROCEDURE (SCHREIBE_ZEICHEN_IN_BWS)
        CALL       SCHREIBE_ZEICHEN_IN_BWS
 
; Retten der Parameter-Register fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        POP        R0
 
; ENDCASE;
M_CASE_029:
 
; IF_THEN_ELSE - Ende
M_IF_028:
 
; PROCEDURE - Ende (SCHREIBE_BYTE_IN_BWS)
        RET
 
; PROCEDURE - Anfang (FUELLE_BWS_MIT_ZEICHEN)
FUELLE_BWS_MIT_ZEICHEN:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DAS_ZEICHEN)
        MOV        R2, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (BWS_POS)
        STS        BWS_POS, R16
        STS        BWS_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (ZEICHEN_ZAEHLER)
        MOV        R0, R16
        MOV        R1, R17
 
; FOR TO DO - Ausdruck / Konstante CONST (LAENGE_BWS)
        LDI        R16, LOW(0x07B3)
        LDI        R17, HIGH(0x07B3)
 
; FOR TO DO - Laden des lokal Word-Zaehlwertes
        MOV        R18, R0
        MOV        R19, R1
 
; FOR TO DO - Vergleichswert Word in Stack
        PUSH       R16
        PUSH       R17
 
; FOR TO DO - Marke_Start
M_FTD_041:
 
; FOR TO DO - Word-Vergleichsteil (TO)
        POP        R17
        POP        R16
        PUSH       R16
        PUSH       R17
        CP         R16, R18
        CPC        R17, R19
        BRCC       M_FTD_042
        RJMP       M_FTD_043
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_042:
 
; Retten der lokalen Parameter fuer PROCEDURE (FUELLE_BWS_MIT_ZEICHEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Parameter (DAS_ZEICHEN) retten
        MOV        R18, R2
 
; lokalen Parameter (DAS_ZEICHEN) an Prozedur (SCHREIBE_ZEICHEN_IN_BWS)
        MOV        R0, R18
 
; Aufruf PROCEDURE (SCHREIBE_ZEICHEN_IN_BWS)
        CALL       SCHREIBE_ZEICHEN_IN_BWS
 
; Retten der Parameter-Register fuer PROCEDURE (FUELLE_BWS_MIT_ZEICHEN)
        POP        R2
        POP        R1
        POP        R0
 
; INC(DAS_ZEICHEN) - Byte
        INC        R2
 
; FOR TO DO - (lokal)Word-INC-Zaehler
        MOV        R18, R0
        MOV        R19, R1
        LDI        R20, 1
        ADD        R18, R20
        CLR        R20
        ADC        R19, R20
        MOV        R0, R18
        MOV        R1, R19
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_041
 
; FOR TO DO - Ende
M_FTD_043:
 
; FOR TO DO - Vergleichswert (Word) vom Stack holen
        POP        R17
        POP        R16
 
; PROCEDURE - Ende (FUELLE_BWS_MIT_ZEICHEN)
        RET
 
; PROCEDURE - Anfang (WRITE)
WRITE:
 
; Zuweisung Quelle - Ausdruck / Length(WRITE_STRING)
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (LAENGE)
        MOV        R1, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x01)
        LDI        R16, 0x01
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R2, R16
 
; FOR TO DO - Ausdruck / lokale, dynamische Variable VAR (LAENGE)
        MOV        R16, R1
 
; FOR TO DO - Laden des lokal Byte-Zaehlwertes
        MOV        R17, R2
 
; FOR TO DO - Vergleichswert lokal Byte in Stack
        PUSH       R16
 
; FOR TO DO - Marke_Start
M_FTD_044:
 
; FOR TO DO - Byte-Vergleichsteil (TO)
        POP        R16
        PUSH       R16
        CP         R16, R17
        BRCC       M_FTD_045
        RJMP       M_FTD_046
 
; FOR TO DO - Beginn der Statements in der Schleife
M_FTD_045:
 
; ARRAY - Ausdruck / lokale, dynamische Variable VAR (B1)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck /; Zuweisung STRING zu CHAR (WRITE_STRING)
        CLR        R17
        LDI        ZL, LOW(WRITE_STRING)
        LDI        ZH, HIGH(WRITE_STRING)
        ADD        ZL, R16
        ADC        ZH, R17
        LD         R16, Z
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (C1)
        MOV        R0, R16
 
; Zuweisung Quelle - Ausdruck /; Zuweisung CharToByte(C1)
        MOV        R16, R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B2)
        MOV        R3, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (WRITE)
        PUSH       R0
        PUSH       R1
        PUSH       R2
        PUSH       R3
 
; Parameter (B2) retten
        MOV        R19, R3
 
; lokalen Parameter (B2) an Prozedur (SCHREIBE_BYTE_IN_BWS)
        MOV        R0, R19
 
; Aufruf PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        CALL       SCHREIBE_BYTE_IN_BWS
 
; Retten der Parameter-Register fuer PROCEDURE (WRITE)
        POP        R3
        POP        R2
        POP        R1
        POP        R0
 
; FOR TO DO - (lokal)Byte-INC-Zaehler
        MOV        R17, R2
        INC        R17
        MOV        R2, R17
 
; FOR TO DO - Sprung zur Auswertung
        RJMP       M_FTD_044
 
; FOR TO DO - Ende
M_FTD_046:
 
; FOR TO DO - Vergleichswert (Byte) vom Stack holen
        POP        R16
 
; PROCEDURE - Ende (WRITE)
        RET
 
; PROCEDURE - Anfang (WRITELN)
WRITELN:
 
; Aufruf PROCEDURE (WRITE)
        CALL       WRITE
 
; Byte-Parameter(1) fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        LDI        R16, 0x0D
        MOV        R0, R16
 
; Aufruf PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        CALL       SCHREIBE_BYTE_IN_BWS
 
; Byte-Parameter(1) fuer PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        LDI        R16, 0x0A
        MOV        R0, R16
 
; Aufruf PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        CALL       SCHREIBE_BYTE_IN_BWS
 
; PROCEDURE - Ende (WRITELN)
        RET
 
; PROCEDURE - Anfang (INIT_CONOUT)
INIT_CONOUT:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (BWS_POS)
        STS        BWS_POS, R16
        STS        BWS_POS+1, R17
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (ESC_SEQUENZ_FOLGT)
        STS        ESC_SEQUENZ_FOLGT, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (CURSOR_IS_ON)
        STS        CURSOR_IS_ON, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x0000)
        LDI        R16, LOW(0x0000)
        LDI        R17, HIGH(0x0000)
 
; Zuweisung Ziel /  VAR (CURSOR_COUNTER)
        STS        CURSOR_COUNTER, R16
        STS        CURSOR_COUNTER+1, R17
 
; Aufruf PROCEDURE (LOESCHE_BWS)
        CALL       LOESCHE_BWS
 
; PROCEDURE - Ende (INIT_CONOUT)
        RET
 
; PROCEDURE - Anfang (ITP3_CLIENT_INIT)
ITP3_CLIENT_INIT:
 
; ClearBit(D0_D)
        CBI        DDRC, 0
 
; ClearBit(D1_D)
        CBI        DDRC, 1
 
; ClearBit(D2_D)
        CBI        DDRC, 2
 
; ClearBit(D3_D)
        CBI        DDRC, 3
 
; ClearBit(DS_D)
        CBI        DDRC, 4
 
; ClearBit(DR_D)
        CBI        DDRC, 5
 
; PROCEDURE - Ende (ITP3_CLIENT_INIT)
        RET
 
; FUNCTION - Anfang (ITP3_HALBBYTE_EINLESEN)
ITP3_HALBBYTE_EINLESEN:
 
; SetBit(LED_GN)
        SBI        PORTB, 2
 
; WHILE DO ...
M_WHILE_047:
 
; WHILE - Ausdruck /; BitHigh(DS_E)
        IN         R16, PINC
        BST        R16, 4
        BRTS       M_VERGL_050
        CLR        R16
        RJMP       M_VERGL_051
M_VERGL_050:
        SER        R16
M_VERGL_051:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_048
        RJMP       M_WHILE_049
M_WHILE_048:
 
; WHILE DO ...
        RJMP       M_WHILE_047
M_WHILE_049:
 
; ClearBit(LED_GN)
        CBI        PORTB, 2
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck /; BitHigh(D0_E)
        IN         R16, PINC
        BST        R16, 0
        BRTS       M_VERGL_055
        CLR        R16
        RJMP       M_VERGL_056
M_VERGL_055:
        SER        R16
M_VERGL_056:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_052
        RJMP       M_IF_053
M_IF_052:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_053:
 
; IF THEN - Ausdruck /; BitHigh(D1_E)
        IN         R16, PINC
        BST        R16, 1
        BRTS       M_VERGL_060
        CLR        R16
        RJMP       M_VERGL_061
M_VERGL_060:
        SER        R16
M_VERGL_061:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_057
        RJMP       M_IF_058
M_IF_057:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x02)
        LDI        R18, 0x02
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_058:
 
; IF THEN - Ausdruck /; BitHigh(D2_E)
        IN         R16, PINC
        BST        R16, 2
        BRTS       M_VERGL_065
        CLR        R16
        RJMP       M_VERGL_066
M_VERGL_065:
        SER        R16
M_VERGL_066:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_062
        RJMP       M_IF_063
M_IF_062:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_063:
 
; IF THEN - Ausdruck /; BitHigh(D3_E)
        IN         R16, PINC
        BST        R16, 3
        BRTS       M_VERGL_070
        CLR        R16
        RJMP       M_VERGL_071
M_VERGL_070:
        SER        R16
M_VERGL_071:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_067
        RJMP       M_IF_068
M_IF_067:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x08)
        LDI        R18, 0x08
 
; Operator OR
        OR         R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF_THEN - Ende
M_IF_068:
 
; ClearBit(DR_A)
        CBI        PORTC, 5
 
; SetBit(LED_GN)
        SBI        PORTB, 2
 
; WHILE DO ...
M_WHILE_072:
 
; WHILE - Ausdruck /; BitLow(DS_E)
        IN         R16, PINC
        BST        R16, 4
        BRTC       M_VERGL_075
        CLR        R16
        RJMP       M_VERGL_076
M_VERGL_075:
        SER        R16
M_VERGL_076:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_073
        RJMP       M_WHILE_074
M_WHILE_073:
 
; WHILE DO ...
        RJMP       M_WHILE_072
M_WHILE_074:
 
; ClearBit(LED_GN)
        CBI        PORTB, 2
 
; SetBit(DR_A)
        SBI        PORTC, 5
 
; RESULT Byte-Variable - FUNCTION (ITP3_HALBBYTE_EINLESEN)
        MOV        R0, R1
 
; Ende Byte - FUNCTION (ITP3_HALBBYTE_EINLESEN)
        MOV        R16, R0
 
; FUNCTION - Ende (ITP3_HALBBYTE_EINLESEN)
        RET
 
; FUNCTION - Anfang (ITP3_BYTE_EINLESEN)
ITP3_BYTE_EINLESEN:
 
; SetBit(DR_A)
        SBI        PORTC, 5
 
; SetBit(DR_D)
        SBI        DDRC, 5
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_BYTE_EINLESEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (ITP3_HALBBYTE_EINLESEN)
        CALL       ITP3_HALBBYTE_EINLESEN
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_BYTE_EINLESEN)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R2, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_BYTE_EINLESEN)
        PUSH       R0
        PUSH       R1
        PUSH       R2
 
; Aufruf Funktion (ITP3_HALBBYTE_EINLESEN)
        CALL       ITP3_HALBBYTE_EINLESEN
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_BYTE_EINLESEN)
        POP        R2
        POP        R1
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; ClearBit(DR_D)
        CBI        DDRC, 5
 
; SHL(B1) - Byte
        LSL        R1
 
; SHL(B1) - Byte
        LSL        R1
 
; SHL(B1) - Byte
        LSL        R1
 
; SHL(B1) - Byte
        LSL        R1
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R16, R2
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R18, R1
 
; Operator +
        ADD        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (RESULT_BYTE)
        MOV        R2, R16
 
; RESULT Byte-Variable - FUNCTION (ITP3_BYTE_EINLESEN)
        MOV        R0, R2
 
; Ende Byte - FUNCTION (ITP3_BYTE_EINLESEN)
        MOV        R16, R0
 
; FUNCTION - Ende (ITP3_BYTE_EINLESEN)
        RET
 
; PROCEDURE - Anfang (ITP3_HALBBYTE_AUSGEBEN)
ITP3_HALBBYTE_AUSGEBEN:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (H_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x01)
        LDI        R18, 0x01
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_080
        CLR        R16
        RJMP       M_VERGL_081
M_VERGL_080:
        SER        R16
M_VERGL_081:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_077
        RJMP       M_IF_078
M_IF_077:
 
; ClearBit(D0_A)
        CBI        PORTC, 0
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_079
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_078:
 
; SetBit(D0_A)
        SBI        PORTC, 0
 
; IF_THEN_ELSE - Ende
M_IF_079:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (H_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x02)
        LDI        R18, 0x02
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_085
        CLR        R16
        RJMP       M_VERGL_086
M_VERGL_085:
        SER        R16
M_VERGL_086:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_082
        RJMP       M_IF_083
M_IF_082:
 
; ClearBit(D1_A)
        CBI        PORTC, 1
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_084
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_083:
 
; SetBit(D1_A)
        SBI        PORTC, 1
 
; IF_THEN_ELSE - Ende
M_IF_084:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (H_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x04)
        LDI        R18, 0x04
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_090
        CLR        R16
        RJMP       M_VERGL_091
M_VERGL_090:
        SER        R16
M_VERGL_091:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_087
        RJMP       M_IF_088
M_IF_087:
 
; ClearBit(D2_A)
        CBI        PORTC, 2
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_089
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_088:
 
; SetBit(D2_A)
        SBI        PORTC, 2
 
; IF_THEN_ELSE - Ende
M_IF_089:
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (H_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x08)
        LDI        R18, 0x08
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; IF THEN - Ausdruck erster Faktor / lokale, dynamische Variable VAR (B1)
        MOV        R16, R1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x00)
        LDI        R18, 0x00
 
; Operator =
        CP         R16, R18
        BREQ       M_VERGL_095
        CLR        R16
        RJMP       M_VERGL_096
M_VERGL_095:
        SER        R16
M_VERGL_096:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_092
        RJMP       M_IF_093
M_IF_092:
 
; ClearBit(D3_A)
        CBI        PORTC, 3
 
; IF_THEN_ELSE - Sprung ans Ende des ELSE-Abschnitts
        RJMP       M_IF_094
 
; IF_THEN_ELSE - Beginn ELSE-Abschnitt
M_IF_093:
 
; SetBit(D3_A)
        SBI        PORTC, 3
 
; IF_THEN_ELSE - Ende
M_IF_094:
 
; ClearBit(DR_A)
        CBI        PORTC, 5
 
; SetBit(LED_GN)
        SBI        PORTB, 2
 
; WHILE DO ...
M_WHILE_097:
 
; WHILE - Ausdruck /; BitLow(DS_E)
        IN         R16, PINC
        BST        R16, 4
        BRTC       M_VERGL_0100
        CLR        R16
        RJMP       M_VERGL_0101
M_VERGL_0100:
        SER        R16
M_VERGL_0101:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_098
        RJMP       M_WHILE_099
M_WHILE_098:
 
; WHILE DO ...
        RJMP       M_WHILE_097
M_WHILE_099:
 
; ClearBit(LED_GN)
        CBI        PORTB, 2
 
; SetBit(DR_A)
        SBI        PORTC, 5
 
; PROCEDURE - Ende (ITP3_HALBBYTE_AUSGEBEN)
        RET
 
; PROCEDURE - Anfang (ITP3_BYTE_AUSGEBEN)
ITP3_BYTE_AUSGEBEN:
 
; SetBit(DR_A)
        SBI        PORTC, 5
 
; SetBit(DR_D)
        SBI        DDRC, 5
 
; SetBit(LED_GN)
        SBI        PORTB, 2
 
; WHILE DO ...
M_WHILE_0102:
 
; WHILE - Ausdruck /; BitHigh(DS_E)
        IN         R16, PINC
        BST        R16, 4
        BRTS       M_VERGL_0105
        CLR        R16
        RJMP       M_VERGL_0106
M_VERGL_0105:
        SER        R16
M_VERGL_0106:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0103
        RJMP       M_WHILE_0104
M_WHILE_0103:
 
; WHILE DO ...
        RJMP       M_WHILE_0102
M_WHILE_0104:
 
; ClearBit(LED_GN)
        CBI        PORTB, 2
 
; SetBit(D0_D)
        SBI        DDRC, 0
 
; SetBit(D1_D)
        SBI        DDRC, 1
 
; SetBit(D2_D)
        SBI        DDRC, 2
 
; SetBit(D3_D)
        SBI        DDRC, 3
 
; Zuweisung Quelle - Ausdruck erster Faktor / lokaler Uebergabeparameter (H_BYTE)
        MOV        R16, R0
 
; Zuweisung Quelle - Ausdruck zweiter Faktor / Zahlenwert (0x0F)
        LDI        R18, 0x0F
 
; Operator AND
        AND        R16, R18
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (B1)
        MOV        R1, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_BYTE_AUSGEBEN)
        PUSH       R0
        PUSH       R1
 
; Parameter (B1) retten
        MOV        R17, R1
 
; lokalen Parameter (B1) an Prozedur (ITP3_HALBBYTE_AUSGEBEN)
        MOV        R0, R17
 
; Aufruf PROCEDURE (ITP3_HALBBYTE_AUSGEBEN)
        CALL       ITP3_HALBBYTE_AUSGEBEN
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_BYTE_AUSGEBEN)
        POP        R1
        POP        R0
 
; SHR(H_BYTE) - Byte
        LSR        R0
 
; SHR(H_BYTE) - Byte
        LSR        R0
 
; SHR(H_BYTE) - Byte
        LSR        R0
 
; SHR(H_BYTE) - Byte
        LSR        R0
 
; SetBit(LED_GN)
        SBI        PORTB, 2
 
; WHILE DO ...
M_WHILE_0107:
 
; WHILE - Ausdruck /; BitHigh(DS_E)
        IN         R16, PINC
        BST        R16, 4
        BRTS       M_VERGL_0110
        CLR        R16
        RJMP       M_VERGL_0111
M_VERGL_0110:
        SER        R16
M_VERGL_0111:
 
; WHILE - Vergleich
        CPI        R16, 0xFF
        BREQ       M_WHILE_0108
        RJMP       M_WHILE_0109
M_WHILE_0108:
 
; WHILE DO ...
        RJMP       M_WHILE_0107
M_WHILE_0109:
 
; ClearBit(LED_GN)
        CBI        PORTB, 2
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_BYTE_AUSGEBEN)
        PUSH       R0
        PUSH       R1
 
; Aufruf PROCEDURE (ITP3_HALBBYTE_AUSGEBEN)
        CALL       ITP3_HALBBYTE_AUSGEBEN
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_BYTE_AUSGEBEN)
        POP        R1
        POP        R0
 
; ClearBit(DR_D)
        CBI        DDRC, 5
 
; ClearBit(D0_D)
        CBI        DDRC, 0
 
; ClearBit(D1_D)
        CBI        DDRC, 1
 
; ClearBit(D2_D)
        CBI        DDRC, 2
 
; ClearBit(D3_D)
        CBI        DDRC, 3
 
; PROCEDURE - Ende (ITP3_BYTE_AUSGEBEN)
        RET
 
; PROCEDURE - Anfang (ITP3_PRG_CONOUT)
ITP3_PRG_CONOUT:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_PRG_CONOUT)
        PUSH       R0
 
; Aufruf Funktion (ITP3_BYTE_EINLESEN)
        CALL       ITP3_BYTE_EINLESEN
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_PRG_CONOUT)
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_BYTE)
        MOV        R0, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_PRG_CONOUT)
        PUSH       R0
 
; Aufruf PROCEDURE (SCHREIBE_BYTE_IN_BWS)
        CALL       SCHREIBE_BYTE_IN_BWS
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_PRG_CONOUT)
        POP        R0
 
; PROCEDURE - Ende (ITP3_PRG_CONOUT)
        RET
 
; PROCEDURE - Anfang (ITP3_PRG_WHO_AM_I)
ITP3_PRG_WHO_AM_I:
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x80)
        LDI        R16, 0x80
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (DATA_BYTE)
        MOV        R0, R16
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_PRG_WHO_AM_I)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_BYTE_AUSGEBEN)
        CALL       ITP3_BYTE_AUSGEBEN
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_PRG_WHO_AM_I)
        POP        R0
 
; PROCEDURE - Ende (ITP3_PRG_WHO_AM_I)
        RET
 
; PROCEDURE - Anfang (ITP3_SERVER_ABFRAGE)
ITP3_SERVER_ABFRAGE:
 
; IF THEN - Ausdruck /; BitLow(DS_E)
        IN         R16, PINC
        BST        R16, 4
        BRTC       M_VERGL_0115
        CLR        R16
        RJMP       M_VERGL_0116
M_VERGL_0115:
        SER        R16
M_VERGL_0116:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0112
        RJMP       M_IF_0113
M_IF_0112:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SERVER_ABFRAGE)
        PUSH       R0
 
; Aufruf Funktion (ITP3_BYTE_EINLESEN)
        CALL       ITP3_BYTE_EINLESEN
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SERVER_ABFRAGE)
        POP        R0
 
; Zuweisung Ziel /  lokale, dynamische Variable VAR (CODE_BYTE)
        MOV        R0, R16
 
; CASE OF - lokale, dynamische Variable VAR (CODE_BYTE)
        MOV        R16, R0
 
; CASE OF - vergleiche Einzel-Element (ITP3_WHO_AM_I)
        CPI        R16, 0x01
        BREQ       M_CASE_0119
        RJMP       M_CASE_0118
M_CASE_0119:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SERVER_ABFRAGE)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_PRG_WHO_AM_I)
        CALL       ITP3_PRG_WHO_AM_I
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SERVER_ABFRAGE)
        POP        R0
 
; CASE - Sprung zu ENDCASE
        RJMP       M_CASE_0117
M_CASE_0118:
 
; CASE OF - vergleiche Einzel-Element (ITP3_CONOUT)
        CPI        R16, 0x03
        BREQ       M_CASE_0121
        RJMP       M_CASE_0120
M_CASE_0121:
 
; Retten der lokalen Parameter fuer PROCEDURE (ITP3_SERVER_ABFRAGE)
        PUSH       R0
 
; Aufruf PROCEDURE (ITP3_PRG_CONOUT)
        CALL       ITP3_PRG_CONOUT
 
; Retten der Parameter-Register fuer PROCEDURE (ITP3_SERVER_ABFRAGE)
        POP        R0
 
; ENDCASE;
M_CASE_0120:
M_CASE_0117:
 
; IF_THEN - Ende
M_IF_0113:
 
; PROCEDURE - Ende (ITP3_SERVER_ABFRAGE)
        RET
 
; Start des Hauptprogramms
RESET:
 
; Initialisieren des Stacks
        LDI        R16, LOW(RAMEND)
        OUT        SPL, R16
 
; Aufruf PROCEDURE (INITPORTS)
        CALL       INITPORTS
 
; SetBit(SL)
        SBI        PORTB, 4
 
; ClearBit(VSYNC)
        CBI        PORTB, 0
 
; ClearBit(HSYNC)
        CBI        PORTB, 1
 
; Word-Parameter(1) fuer PROCEDURE (INIT_TIMER1_COMPA)
        LDI        R16, LOW(0x02FA)
        MOV        R0, R16
        LDI        R17, HIGH(0x02FA)
        MOV        R1, R17
 
; Aufruf PROCEDURE (INIT_TIMER1_COMPA)
        CALL       INIT_TIMER1_COMPA
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (WERT_YL)
        STS        WERT_YL, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x00)
        LDI        R16, 0x00
 
; Zuweisung Ziel /  VAR (WERT_YH)
        STS        WERT_YH, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x20)
        LDI        R16, 0x20
 
; Zuweisung Ziel /  VAR (FUELLBYTE)
        STS        FUELLBYTE, R16
 
; Zuweisung Quelle - Ausdruck / Zahlenwert (0x10)
        LDI        R16, 0x10
 
; Zuweisung Ziel /  VAR (WERT_ZH)
        STS        WERT_ZH, R16
 
; ASM
 ldi   R16, low(BWS)
 sts   Wert_BWS_L, R16

 ldi   R16, high(BWS)
 sts   Wert_BWS_H, R16

 
 
; Aufruf PROCEDURE (INIT_CONOUT)
        CALL       INIT_CONOUT
 
; Interrupt erlauben
        SEI
 
; LOOP - Start_Marke
M_LOOP_0122:
 
; Aufruf PROCEDURE (ITP3_SERVER_ABFRAGE)
        CALL       ITP3_SERVER_ABFRAGE
 
; INC(CURSOR_COUNTER) - Word
        LDS        R24, CURSOR_COUNTER
        LDS        R25, CURSOR_COUNTER+1
        ADIW       R25:R24, 1
        STS        CURSOR_COUNTER, R24
        STS        CURSOR_COUNTER+1, R25
 
; IF THEN - Ausdruck erster Faktor / Word-VAR (CURSOR_COUNTER)
        LDS        R16, CURSOR_COUNTER
        LDS        R17, CURSOR_COUNTER+1
 
; IF THEN - Ausdruck zweiter Faktor / Zahlenwert (0x2710)
        LDI        R18, LOW(0x2710)
        LDI        R19, HIGH(0x2710)
 
; Operator =
        CP         R16, R18
        CPC        R17, R19
        BREQ       M_VERGL_0126
        CLR        R16
        CLR        R16
        RJMP       M_VERGL_0127
M_VERGL_0126:
        SER        R16
M_VERGL_0127:
 
; IF_THEN - Vergleich
        CPI        R16, 0xFF
        BREQ       M_IF_0123
        RJMP       M_IF_0124
M_IF_0123:
 
; Aufruf PROCEDURE (SWITCH_CURSOR)
        CALL       SWITCH_CURSOR
 
; IF_THEN - Ende
M_IF_0124:
 
; LOOP - Ende
        RJMP       M_LOOP_0122
 
; ASM
font:
 
.org 2048
 
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0xFF,0x00,0xFF,0xFF,0xFF,0xFF,0xFF    ; 00FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; 01FH
.db 0xFF,0xFF,0xFF,0xFF,0xE7,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; 02FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; 03FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; 04FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xEF,0xFF    ; 05FH
.db 0xCF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; 06FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; 07FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC7    ; 08FH
.db 0xE7,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; 09FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0x89,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; 0AFH
.db 0xEE,0xAA,0x22,0xE7,0xE7,0xE7,0xC9,0xFF,0xFF,0xC9,0xC9,0xFF,0xC9,0xC9,0xE7,0xFF    ; 0BFH
.db 0xE7,0xE7,0xFF,0xE7,0xFF,0xE7,0xE7,0xC9,0xC9,0xFF,0xC9,0xFF,0xC9,0xFF,0xC9,0xE7    ; 0CFH
.db 0xC9,0xFF,0xFF,0xC9,0xE7,0xFF,0xFF,0xC9,0xE7,0xE7,0xFF,0x00,0xFF,0x0F,0xF0,0x00    ; 0DFH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; 0EFH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xE7,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; 0FFH
 
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0xFF,0x00,0xFF,0xFF,0xFF,0xFF,0xFF    ; 10FH
.db 0x7F,0xFD,0xFF,0xFF,0xFF,0x83,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; 11FH
.db 0xFF,0xFF,0x99,0xFF,0xE7,0xFF,0xFF,0xCF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; 12FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; 13FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; 14FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC7,0xFF    ; 15FH
.db 0xCF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; 16FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; 17FH
.db 0xFF,0xFF,0xF3,0xEF,0xFF,0x9F,0xC7,0xFF,0xEF,0xFF,0x9F,0xFF,0xE7,0x9F,0x39,0x93    ; 18FH
.db 0xCF,0xFF,0xFF,0xEF,0xFF,0x9F,0xCF,0x9F,0xFF,0x39,0x39,0xE7,0xC7,0xFF,0x03,0xF1    ; 19FH
.db 0xE7,0xF3,0xE7,0xE7,0xFF,0x23,0xC3,0xC7,0xFF,0xFF,0xFF,0x3F,0x3F,0xFF,0xFF,0xFF    ; 1AFH
.db 0xBB,0x55,0x88,0xE7,0xE7,0xE7,0xC9,0xFF,0xFF,0xC9,0xC9,0xFF,0xC9,0xC9,0xE7,0xFF    ; 1BFH
.db 0xE7,0xE7,0xFF,0xE7,0xFF,0xE7,0xE7,0xC9,0xC9,0xFF,0xC9,0xFF,0xC9,0xFF,0xC9,0xE7    ; 1CFH
.db 0xC9,0xFF,0xFF,0xC9,0xE7,0xFF,0xFF,0xC9,0xE7,0xE7,0xFF,0x00,0xFF,0x0F,0xF0,0x00    ; 1DFH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; 1EFH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xE7,0xFF,0xFF,0xC7,0xFF,0xFF,0xF0,0x27,0x8F,0xFF,0xFF    ; 1FFH
 
.db 0xFF,0x81,0x81,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0xFF,0x00,0xE1,0xC3,0xC0,0x80,0xFF    ; 20FH
.db 0x3F,0xF9,0xE7,0x99,0x80,0x39,0xFF,0xE7,0xE7,0xE7,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; 21FH
.db 0xFF,0xE7,0x99,0xFF,0x83,0xFF,0xC7,0xCF,0xF3,0xCF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; 22FH
.db 0x83,0xE7,0x83,0x83,0xF3,0x01,0xC7,0x01,0x83,0x83,0xFF,0xFF,0xFF,0xFF,0xFF,0x83    ; 23FH
.db 0x83,0xEF,0x03,0xC3,0x07,0x01,0x01,0xC3,0x39,0xC3,0xE1,0x19,0x0F,0x3C,0x39,0x83    ; 24FH
.db 0x03,0x83,0x03,0x83,0x00,0x39,0x3C,0x3C,0x3C,0x3C,0x00,0xC3,0xFF,0xC3,0x93,0xFF    ; 25FH
.db 0xE7,0xFF,0x1F,0xFF,0xE3,0xFF,0xC7,0xFF,0x1F,0xE7,0xF9,0x1F,0xC7,0xFF,0xFF,0xFF    ; 26FH
.db 0xFF,0xFF,0xFF,0xFF,0xEF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xF1,0xE7,0x8F,0x89,0xFF    ; 27FH
.db 0xC3,0x33,0xE7,0xC7,0x33,0xCF,0x93,0xFF,0xC7,0x39,0xCF,0x99,0xC3,0xCF,0xFF,0xC7    ; 28FH
.db 0x9F,0xFF,0xC1,0xC7,0x39,0xCF,0x87,0xCF,0x39,0xFF,0xFF,0xE7,0x93,0x3C,0x99,0xE4    ; 29FH
.db 0xCF,0xE7,0xCF,0xCF,0x89,0xFF,0x93,0x93,0xCF,0xFF,0xFF,0x3F,0x3F,0xE7,0xFF,0xFF    ; 2AFH
.db 0xEE,0xAA,0x22,0xE7,0xE7,0xE7,0xC9,0xFF,0xFF,0xC9,0xC9,0xFF,0xC9,0xC9,0xE7,0xFF    ; 2BFH
.db 0xE7,0xE7,0xFF,0xE7,0xFF,0xE7,0xE7,0xC9,0xC9,0xFF,0xC9,0xFF,0xC9,0xFF,0xC9,0xE7    ; 2CFH
.db 0xC9,0xFF,0xFF,0xC9,0xE7,0xFF,0xFF,0xC9,0xE7,0xE7,0xFF,0x00,0xFF,0x0F,0xF0,0x00    ; 2DFH
.db 0xFF,0x87,0x01,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC7,0xE1,0xFF,0xFF,0xE3,0xFF    ; 2EFH
.db 0xFF,0xFF,0xFF,0xFF,0xF1,0xE7,0xFF,0xFF,0x93,0xFF,0xFF,0xF3,0x93,0x27,0xFF,0xFF    ; 2FFH
 
.db 0xFF,0x7E,0x00,0xFF,0xFF,0xE7,0xE7,0xFF,0x00,0xFF,0x00,0xF1,0x99,0xCC,0x9C,0xE7    ; 30FH
.db 0x1F,0xF1,0xC3,0x99,0x24,0x9F,0xFF,0xC3,0xC3,0xE7,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; 31FH
.db 0xFF,0xC3,0x99,0x93,0x39,0xFF,0x93,0xCF,0xE7,0xE7,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; 32FH
.db 0x39,0xC7,0x39,0x39,0xE3,0x3F,0x9F,0x39,0x39,0x39,0xFF,0xFF,0xF9,0xFF,0x9F,0x39    ; 33FH
.db 0x39,0xC7,0x99,0x99,0x93,0x99,0x99,0x99,0x39,0xE7,0xF3,0x99,0x9F,0x18,0x19,0x39    ; 34FH
.db 0x99,0x39,0x99,0x39,0x24,0x39,0x3C,0x3C,0x3C,0x3C,0x3C,0xCF,0x7F,0xF3,0x39,0xFF    ; 35FH
.db 0xFF,0xFF,0x9F,0xFF,0xF3,0xFF,0x93,0xFF,0x9F,0xE7,0xF9,0x9F,0xE7,0xFF,0xFF,0xFF    ; 36FH
.db 0xFF,0xFF,0xFF,0xFF,0xCF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE7,0xE7,0xE7,0x23,0xFF    ; 37FH
.db 0x99,0xFF,0xCF,0x93,0xFF,0xE7,0xC7,0xFF,0x93,0xFF,0xE7,0xFF,0x99,0xE7,0xEF,0xFF    ; 38FH
.db 0xFF,0xFF,0x93,0x93,0xFF,0xE7,0x33,0xE7,0xFF,0x83,0x39,0x81,0x9B,0x99,0x99,0xE7    ; 39FH
.db 0x9F,0xCF,0x9F,0x9F,0x23,0x39,0x93,0x93,0xCF,0xFF,0xFF,0x3D,0x3D,0xE7,0xFF,0xFF    ; 3AFH
.db 0xBB,0x55,0x88,0xE7,0xE7,0xE7,0xC9,0xFF,0xFF,0xC9,0xC9,0xFF,0xC9,0xC9,0xE7,0xFF    ; 3BFH
.db 0xE7,0xE7,0xFF,0xE7,0xFF,0xE7,0xE7,0xC9,0xC9,0xFF,0xC9,0xFF,0xC9,0xFF,0xC9,0xE7    ; 3CFH
.db 0xC9,0xFF,0xFF,0xC9,0xE7,0xFF,0xFF,0xC9,0xE7,0xE7,0xFF,0x00,0xFF,0x0F,0xF0,0x00    ; 3DFH
.db 0xFF,0x33,0x39,0xFF,0x01,0xFF,0xFF,0xFF,0x81,0xC7,0x93,0xCF,0xFF,0xFC,0xCF,0x83    ; 3EFH
.db 0xFF,0xFF,0xCF,0xF3,0xE4,0xE7,0xFF,0xFF,0x93,0xFF,0xFF,0xF3,0x93,0xCF,0xFF,0xFF    ; 3FFH
 
.db 0xFF,0x5A,0x24,0x93,0xEF,0xC3,0xC3,0xFF,0x00,0xFF,0x00,0xE5,0x99,0xC0,0x80,0xE7    ; 40FH
.db 0x0F,0xE1,0x81,0x99,0x24,0xC7,0xFF,0x81,0x81,0xE7,0xFF,0xFF,0xFF,0xFF,0xEF,0x01    ; 41FH
.db 0xFF,0xC3,0xDB,0x93,0x3D,0x3D,0x93,0x9F,0xCF,0xF3,0xFF,0xFF,0xFF,0xFF,0xFF,0xFD    ; 42FH
.db 0x39,0x87,0xF9,0xF9,0xC3,0x3F,0x3F,0xF9,0x39,0x39,0xE7,0xE7,0xF3,0xFF,0xCF,0x39    ; 43FH
.db 0x39,0x93,0x99,0x3D,0x99,0x9D,0x9D,0x3D,0x39,0xE7,0xF3,0x99,0x9F,0x00,0x09,0x39    ; 44FH
.db 0x99,0x39,0x99,0x39,0x66,0x39,0x3C,0x3C,0x99,0x3C,0x79,0xCF,0x3F,0xF3,0xFF,0xFF    ; 45FH
.db 0xFF,0xFF,0x9F,0xFF,0xF3,0xFF,0x9B,0xFF,0x9F,0xFF,0xFF,0x9F,0xE7,0xFF,0xFF,0xFF    ; 46FH
.db 0xFF,0xFF,0xFF,0xFF,0xCF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE7,0xE7,0xE7,0xFF,0xEF    ; 47FH
.db 0x3D,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC3,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC7,0xC7    ; 48FH
.db 0x01,0xFF,0x33,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x39,0x39,0x3C,0x9F,0xC3,0x83,0xE7    ; 49FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0x19,0xC1,0xC7,0xFF,0xFF,0xFF,0x39,0x39,0xFF,0xFF,0xFF    ; 4AFH
.db 0xEE,0xAA,0x22,0xE7,0xE7,0xE7,0xC9,0xFF,0xFF,0xC9,0xC9,0xFF,0xC9,0xC9,0xE7,0xFF    ; 4BFH
.db 0xE7,0xE7,0xFF,0xE7,0xFF,0xE7,0xE7,0xC9,0xC9,0xFF,0xC9,0xFF,0xC9,0xFF,0xC9,0xE7    ; 4CFH
.db 0xC9,0xFF,0xFF,0xC9,0xE7,0xFF,0xFF,0xC9,0xE7,0xE7,0xFF,0x00,0xFF,0x0F,0xF0,0x00    ; 4DFH
.db 0xFF,0x33,0x39,0x01,0x39,0xFF,0x99,0x89,0xE7,0x93,0x39,0xE7,0xFF,0xF9,0x9F,0x39    ; 4EFH
.db 0x01,0xE7,0xE7,0xE7,0xE4,0xE7,0xE7,0xFF,0xC7,0xFF,0xFF,0xF3,0x93,0x9F,0x83,0xFF    ; 4FFH
 
.db 0xFF,0x7E,0x00,0x01,0xC7,0xC3,0x81,0xFF,0x00,0xC3,0x3C,0xCD,0x99,0xCF,0x9C,0x24    ; 50FH
.db 0x07,0xC1,0xE7,0x99,0x24,0x93,0xFF,0xE7,0xE7,0xE7,0xE7,0xCF,0xFF,0xDB,0xC7,0x01    ; 51FH
.db 0xFF,0xC3,0xFF,0x01,0x3F,0x39,0xC7,0xFF,0xCF,0xF3,0x99,0xE7,0xFF,0xFF,0xFF,0xF9    ; 52FH
.db 0x31,0xE7,0xF3,0xF9,0x93,0x3F,0x3F,0xF9,0x39,0x39,0xE7,0xE7,0xE7,0x81,0xE7,0xF3    ; 53FH
.db 0x39,0x39,0x99,0x3F,0x99,0x97,0x97,0x3F,0x39,0xE7,0xF3,0x93,0x9F,0x00,0x01,0x39    ; 54FH
.db 0x99,0x39,0x99,0x9F,0xE7,0x39,0x3C,0x3C,0xC3,0x99,0xF3,0xCF,0x1F,0xF3,0xFF,0xFF    ; 55FH
.db 0xFF,0x87,0x87,0x83,0xC3,0x83,0x9F,0x89,0x93,0xC7,0xF1,0x99,0xE7,0x19,0x23,0x83    ; 56FH
.db 0x23,0x89,0x23,0x83,0x03,0x33,0x3C,0x3C,0x3C,0x39,0x01,0xE7,0xE7,0xE7,0xFF,0xC7    ; 57FH
.db 0x3F,0x33,0x83,0x87,0x87,0x87,0x87,0x99,0x83,0x83,0x83,0xC7,0xC7,0xC7,0x93,0x93    ; 58FH
.db 0x99,0x91,0x33,0x83,0x83,0x83,0x33,0x33,0x39,0x39,0x39,0x3F,0x0F,0xE7,0x9D,0xE7    ; 59FH
.db 0x87,0xC7,0x83,0x33,0x23,0x09,0xFF,0xFF,0xCF,0xFF,0xFF,0x33,0x33,0xE7,0xC9,0x27    ; 5AFH
.db 0xBB,0x55,0x88,0xE7,0xE7,0x07,0xC9,0xFF,0x07,0x09,0xC9,0x01,0x09,0xC9,0x07,0xFF    ; 5BFH
.db 0xE7,0xE7,0xFF,0xE7,0xFF,0xE7,0xE0,0xC9,0xC8,0xC0,0x08,0x00,0xC8,0x00,0x08,0x00    ; 5CFH
.db 0xC9,0x00,0xFF,0xC9,0xE0,0xE0,0xFF,0xC9,0x00,0xE7,0xFF,0x00,0xFF,0x0F,0xF0,0x00    ; 5DFH
.db 0x89,0x33,0x3F,0x93,0x9F,0x81,0x99,0x23,0xC3,0x39,0x39,0xF3,0x81,0x81,0x9F,0x39    ; 5EFH
.db 0xFF,0xE7,0xF3,0xCF,0xE4,0xE7,0xE7,0x89,0xFF,0xFF,0xFF,0xF3,0x93,0x37,0x83,0xFF    ; 5FFH
 
.db 0xFF,0x7E,0x00,0x01,0x83,0x18,0x00,0xE7,0x18,0x99,0x66,0x87,0x99,0xCF,0x9C,0xC3    ; 60FH
.db 0x01,0x01,0xE7,0x99,0x84,0x39,0xFF,0xE7,0xE7,0xE7,0xF3,0x9F,0x3F,0x99,0xC7,0x83    ; 61FH
.db 0xFF,0xE7,0xFF,0x93,0x83,0xF3,0x89,0xFF,0xCF,0xF3,0xC3,0xE7,0xFF,0xFF,0xFF,0xF3    ; 62FH
.db 0x21,0xE7,0xE7,0xC3,0x33,0x03,0x03,0xF3,0x83,0x81,0xFF,0xFF,0xCF,0xFF,0xF3,0xE7    ; 63FH
.db 0x21,0x39,0x83,0x3F,0x99,0x87,0x87,0x3F,0x01,0xE7,0xF3,0x87,0x9F,0x24,0x21,0x39    ; 64FH
.db 0x83,0x39,0x83,0xC7,0xE7,0x39,0x3C,0x3C,0xE7,0xC3,0xE7,0xCF,0x8F,0xF3,0xFF,0xFF    ; 65FH
.db 0xFF,0xF3,0x93,0x39,0x93,0x39,0x0F,0x33,0x89,0xE7,0xF9,0x93,0xE7,0x00,0x99,0x39    ; 66FH
.db 0x99,0x33,0x89,0x39,0xCF,0x33,0x3C,0x3C,0x99,0x39,0x33,0x8F,0xFF,0xF1,0xFF,0x93    ; 67FH
.db 0x3F,0x33,0x39,0xF3,0xF3,0xF3,0xF3,0x9F,0x39,0x39,0x39,0xE7,0xE7,0xE7,0x39,0x39    ; 68FH
.db 0x9F,0xC4,0x01,0x39,0x39,0x39,0x33,0x33,0x39,0x39,0x39,0x3F,0x9F,0x00,0x99,0x81    ; 69FH
.db 0xF3,0xE7,0x39,0x33,0x99,0x01,0x81,0x83,0xCF,0x01,0x01,0xE7,0xE7,0xE7,0x93,0x93    ; 6AFH
.db 0xEE,0xAA,0x22,0xE7,0xE7,0xE7,0xC9,0xFF,0xE7,0xF9,0xC9,0xF9,0xF9,0xC9,0xE7,0xFF    ; 6BFH
.db 0xE7,0xE7,0xFF,0xE7,0xFF,0xE7,0xE7,0xC9,0xCF,0xCF,0xFF,0xFF,0xCF,0xFF,0xFF,0xFF    ; 6CFH
.db 0xC9,0xFF,0xFF,0xC9,0xE7,0xE7,0xFF,0xC9,0xE7,0xE7,0xFF,0x00,0xFF,0x0F,0xF0,0x00    ; 6DFH
.db 0x23,0x27,0x3F,0x93,0xCF,0x27,0x99,0xE7,0x99,0x39,0x39,0xC1,0x24,0x24,0x83,0x39    ; 6EFH
.db 0xFF,0x81,0xF9,0x9F,0xE7,0xE7,0xFF,0x23,0xFF,0xFF,0xFF,0xF3,0x93,0x07,0x83,0xFF    ; 6FFH
 
.db 0xFF,0x42,0x3C,0x01,0x01,0x18,0x00,0xC3,0x3C,0xBD,0x42,0x33,0xC3,0xCF,0x9C,0x18    ; 70FH
.db 0x07,0xC1,0xE7,0x99,0xE4,0x39,0xFF,0xE7,0xE7,0xE7,0x01,0x01,0x3F,0x00,0x83,0x83    ; 71FH
.db 0xFF,0xE7,0xFF,0x93,0xF9,0xE7,0x23,0xFF,0xCF,0xF3,0x00,0x81,0xFF,0x81,0xFF,0xE7    ; 72FH
.db 0x09,0xE7,0xCF,0xF9,0x01,0xF9,0x39,0xE7,0x39,0xF9,0xFF,0xFF,0x9F,0xFF,0xF9,0xE7    ; 73FH
.db 0x21,0x01,0x99,0x3F,0x99,0x97,0x97,0x21,0x39,0xE7,0xF3,0x87,0x9F,0x3C,0x31,0x39    ; 74FH
.db 0x9F,0x39,0x93,0xF3,0xE7,0x39,0x3C,0x24,0xE7,0xE7,0xCF,0xCF,0xC7,0xF3,0xFF,0xFF    ; 75FH
.db 0xFF,0x83,0x99,0x3F,0x33,0x01,0x9F,0x33,0x99,0xE7,0xF9,0x87,0xE7,0x24,0x99,0x39    ; 76FH
.db 0x99,0x33,0x99,0x9F,0xCF,0x33,0x3C,0x3C,0xC3,0x39,0xE7,0xE7,0xE7,0xE7,0xFF,0x39    ; 77FH
.db 0x3F,0x33,0x01,0x83,0x83,0x83,0x83,0x9F,0x01,0x01,0x01,0xE7,0xE7,0xE7,0x39,0x39    ; 78FH
.db 0x83,0xE4,0x33,0x39,0x39,0x39,0x33,0x33,0x39,0x39,0x39,0x3F,0x9F,0xE7,0x90,0xE7    ; 79FH
.db 0x83,0xE7,0x39,0x33,0x99,0x21,0xFF,0xFF,0x9F,0x3F,0xF9,0xCF,0xCF,0xE7,0x27,0xC9    ; 7AFH
.db 0xBB,0x55,0x88,0xE7,0x07,0x07,0x09,0x01,0x07,0x09,0xC9,0x09,0x01,0x01,0x07,0x07    ; 7BFH
.db 0xE0,0x00,0x00,0xE0,0x00,0x00,0xE0,0xC8,0xC0,0xC8,0x00,0x08,0xC8,0x00,0x08,0x00    ; 7CFH
.db 0x00,0x00,0x00,0xC0,0xE0,0xE0,0xC0,0x00,0x00,0x07,0xE0,0x00,0x00,0x0F,0xF0,0xFF    ; 7DFH
.db 0x27,0x33,0x3F,0x93,0xE7,0x27,0x99,0xE7,0x99,0x01,0x93,0x99,0x24,0x24,0x9F,0x39    ; 7EFH
.db 0x01,0xE7,0xF3,0xCF,0xE7,0xE7,0x81,0xFF,0xFF,0xE7,0xFF,0x13,0xFF,0xFF,0x83,0xFF    ; 7FFH
 
.db 0xFF,0x66,0x18,0x01,0x83,0x18,0x81,0xC3,0x3C,0xBD,0x42,0x33,0xE7,0xCF,0x9C,0xC3    ; 80FH
.db 0x0F,0xE1,0x81,0x99,0xE4,0x93,0x01,0x81,0xE7,0xE7,0xF3,0x9F,0x3F,0x99,0x83,0xC7    ; 81FH
.db 0xFF,0xE7,0xFF,0x93,0xF9,0xCF,0x33,0xFF,0xCF,0xF3,0xC3,0xE7,0xFF,0xFF,0xFF,0xCF    ; 82FH
.db 0x19,0xE7,0x9F,0xF9,0xF3,0xF9,0x39,0xCF,0x39,0xF9,0xFF,0xFF,0xCF,0x81,0xF3,0xE7    ; 83FH
.db 0x21,0x39,0x99,0x3F,0x99,0x9F,0x9F,0x39,0x39,0xE7,0x33,0x93,0x9F,0x3C,0x39,0x39    ; 84FH
.db 0x9F,0x39,0x99,0xF9,0xE7,0x39,0x3C,0x24,0xC3,0xE7,0x9F,0xCF,0xE3,0xF3,0xFF,0xFF    ; 85FH
.db 0xFF,0x33,0x99,0x3F,0x33,0x3F,0x9F,0x33,0x99,0xE7,0xF9,0x87,0xE7,0x24,0x99,0x39    ; 86FH
.db 0x99,0x33,0x9F,0xC7,0xCF,0x33,0x3C,0x24,0xE7,0x39,0xCF,0xE7,0xE7,0xE7,0xFF,0x39    ; 87FH
.db 0x3D,0x33,0x3F,0x33,0x33,0x33,0x33,0x99,0x3F,0x3F,0x3F,0xE7,0xE7,0xE7,0x01,0x01    ; 88FH
.db 0x9F,0x81,0x33,0x39,0x39,0x39,0x33,0x33,0x39,0x39,0x39,0x3C,0x9F,0x00,0x99,0xE7    ; 89FH
.db 0x33,0xE7,0x39,0x33,0x99,0x31,0xFF,0xFF,0x3F,0x3F,0xF9,0x9F,0x99,0xC3,0x93,0x93    ; 8AFH
.db 0xEE,0xAA,0x22,0xE7,0xE7,0xE7,0xC9,0xC9,0xE7,0xC9,0xC9,0xC9,0xFF,0xFF,0xFF,0xE7    ; 8BFH
.db 0xFF,0xFF,0xE7,0xE7,0xFF,0xE7,0xE7,0xC9,0xFF,0xC9,0xFF,0xC9,0xC9,0xFF,0xC9,0xFF    ; 8CFH
.db 0xFF,0xE7,0xC9,0xFF,0xFF,0xE7,0xC9,0xC9,0xE7,0xFF,0xE7,0x00,0x00,0x0F,0xF0,0xFF    ; 8DFH
.db 0x27,0x39,0x3F,0x93,0xCF,0x27,0x99,0xE7,0x99,0x39,0x93,0x99,0x24,0x0C,0x9F,0x39    ; 8EFH
.db 0xFF,0xE7,0xE7,0xE7,0xE7,0x27,0xFF,0x89,0xFF,0xE7,0xE7,0x93,0xFF,0xFF,0x83,0xFF    ; 8FFH
 
.db 0xFF,0x7E,0x00,0x83,0xC7,0xE7,0xE7,0xE7,0x18,0x99,0x66,0x33,0x81,0x8F,0x98,0x24    ; 90FH
.db 0x1F,0xF1,0xC3,0xFF,0xE4,0xC7,0x01,0xC3,0xE7,0x81,0xE7,0xCF,0x01,0xDB,0x01,0xC7    ; 91FH
.db 0xFF,0xFF,0xFF,0x01,0x79,0x9F,0x33,0xFF,0xCF,0xF3,0x99,0xE7,0xE7,0xFF,0xFF,0x9F    ; 92FH
.db 0x39,0xE7,0x3F,0xF9,0xF3,0xF9,0x39,0xCF,0x39,0xF9,0xE7,0xE7,0xE7,0xFF,0xE7,0xFF    ; 93FH
.db 0x23,0x39,0x99,0x3D,0x99,0x9D,0x9F,0x39,0x39,0xE7,0x33,0x99,0x9D,0x3C,0x39,0x39    ; 94FH
.db 0x9F,0x29,0x99,0x39,0xE7,0x39,0x99,0x00,0x99,0xE7,0x3E,0xCF,0xF1,0xF3,0xFF,0xFF    ; 95FH
.db 0xFF,0x33,0x99,0x3F,0x33,0x3F,0x9F,0x33,0x99,0xE7,0xF9,0x93,0xE7,0x24,0x99,0x39    ; 96FH
.db 0x99,0x33,0x9F,0xF3,0xCF,0x33,0x99,0x24,0xC3,0x39,0x9F,0xE7,0xE7,0xE7,0xFF,0x39    ; 97FH
.db 0x99,0x33,0x3F,0x33,0x33,0x33,0x33,0xC3,0x3F,0x3F,0x3F,0xE7,0xE7,0xE7,0x39,0x39    ; 98FH
.db 0x9F,0x27,0x33,0x39,0x39,0x39,0x33,0x33,0x39,0x39,0x39,0x81,0x9F,0xE7,0x99,0xE7    ; 99FH
.db 0x33,0xE7,0x39,0x33,0x99,0x39,0xFF,0xFF,0x39,0x3F,0xF9,0x31,0x31,0xC3,0xC9,0x27    ; 9AFH
.db 0xBB,0x55,0x88,0xE7,0xE7,0xE7,0xC9,0xC9,0xE7,0xC9,0xC9,0xC9,0xFF,0xFF,0xFF,0xE7    ; 9BFH
.db 0xFF,0xFF,0xE7,0xE7,0xFF,0xE7,0xE7,0xC9,0xFF,0xC9,0xFF,0xC9,0xC9,0xFF,0xC9,0xFF    ; 9CFH
.db 0xFF,0xE7,0xC9,0xFF,0xFF,0xE7,0xC9,0xC9,0xE7,0xFF,0xE7,0x00,0x00,0x0F,0xF0,0xFF    ; 9DFH
.db 0x27,0x39,0x3F,0x93,0x9F,0x27,0x83,0xE7,0xC3,0x39,0x93,0x99,0x81,0x81,0x9F,0x39    ; 9EFH
.db 0xFF,0xFF,0xCF,0xF3,0xE7,0x27,0xE7,0x23,0xFF,0xFF,0xFF,0x93,0xFF,0xFF,0x83,0xFF    ; 9FFH
 
.db 0xFF,0x7E,0x00,0xC7,0xEF,0xE7,0xE7,0xFF,0x00,0xC3,0x3C,0x33,0xE7,0x0F,0x18,0xE7    ; A0FH
.db 0x3F,0xF9,0xE7,0x99,0xE4,0xF3,0x01,0xE7,0xE7,0xC3,0xFF,0xFF,0xFF,0xFF,0x01,0xEF    ; A1FH
.db 0xFF,0xE7,0xFF,0x93,0x39,0x39,0x33,0xFF,0xE7,0xE7,0xFF,0xFF,0xE7,0xFF,0xE7,0x3F    ; A2FH
.db 0x39,0xE7,0x39,0x39,0xF3,0x39,0x39,0xCF,0x39,0xF3,0xE7,0xE7,0xF3,0xFF,0xCF,0xE7    ; A3FH
.db 0x3F,0x39,0x99,0x99,0x93,0x99,0x9F,0x99,0x39,0xE7,0x33,0x99,0x99,0x3C,0x39,0x39    ; A4FH
.db 0x9F,0x21,0x99,0x39,0xE7,0x39,0xC3,0x99,0x3C,0xE7,0x3C,0xCF,0xF9,0xF3,0xFF,0xFF    ; A5FH
.db 0xFF,0x33,0x99,0x39,0x33,0x39,0x9F,0x33,0x99,0xE7,0xF9,0x99,0xE7,0x24,0x99,0x39    ; A6FH
.db 0x99,0x33,0x9F,0x39,0xC9,0x33,0xC3,0x00,0x99,0x39,0x39,0xE7,0xE7,0xE7,0xFF,0x01    ; A7FH
.db 0xC3,0x33,0x39,0x33,0x33,0x33,0x33,0xF3,0x39,0x39,0x39,0xE7,0xE7,0xE7,0x39,0x39    ; A8FH
.db 0x99,0x23,0x33,0x39,0x39,0x39,0x33,0x33,0x39,0x39,0x39,0xE7,0x19,0xE7,0x99,0xE7    ; A9FH
.db 0x33,0xE7,0x39,0x33,0x99,0x39,0xFF,0xFF,0x39,0x3F,0xF9,0x64,0x69,0xC3,0xFF,0xFF    ; AAFH
.db 0xEE,0xAA,0x22,0xE7,0xE7,0xE7,0xC9,0xC9,0xE7,0xC9,0xC9,0xC9,0xFF,0xFF,0xFF,0xE7    ; ABFH
.db 0xFF,0xFF,0xE7,0xE7,0xFF,0xE7,0xE7,0xC9,0xFF,0xC9,0xFF,0xC9,0xC9,0xFF,0xC9,0xFF    ; ACFH
.db 0xFF,0xE7,0xC9,0xFF,0xFF,0xE7,0xC9,0xC9,0xE7,0xFF,0xE7,0x00,0x00,0x0F,0xF0,0xFF    ; ADFH
.db 0x23,0x39,0x3F,0x93,0x39,0x27,0x9F,0xE7,0xE7,0x93,0x93,0x99,0xFF,0x9F,0xCF,0x39    ; AEFH
.db 0x01,0xFF,0xFF,0xFF,0xE7,0x27,0xE7,0xFF,0xFF,0xFF,0xFF,0xC3,0xFF,0xFF,0x83,0xFF    ; AFFH
 
.db 0xFF,0x81,0x81,0xEF,0xFF,0xC3,0xC3,0xFF,0x00,0xFF,0x00,0x87,0xE7,0x1F,0x19,0xE7    ; B0FH
.db 0x7F,0xFD,0xFF,0x99,0xE4,0x39,0x01,0x81,0xE7,0xE7,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; B1FH
.db 0xFF,0xE7,0xFF,0x93,0x83,0x79,0x89,0xFF,0xF3,0xCF,0xFF,0xFF,0xE7,0xFF,0xE7,0x7F    ; B2FH
.db 0x83,0x81,0x01,0x83,0xE1,0x83,0x83,0xCF,0x83,0x87,0xFF,0xCF,0xF9,0xFF,0x9F,0xE7    ; B3FH
.db 0x83,0x39,0x03,0xC3,0x07,0x01,0x0F,0xC5,0x39,0xC3,0x87,0x19,0x01,0x3C,0x39,0x83    ; B4FH
.db 0x0F,0x83,0x19,0x83,0xC3,0x83,0xE7,0x99,0x3C,0xC3,0x00,0xC3,0xFD,0xC3,0xFF,0xFF    ; B5FH
.db 0xFF,0x89,0x83,0x83,0x89,0x83,0x0F,0x83,0x19,0xC3,0xF9,0x19,0xC3,0x24,0x99,0x83    ; B6FH
.db 0x83,0x83,0x0F,0x83,0xE3,0x89,0xE7,0x99,0x3C,0x81,0x01,0xF1,0xE7,0x8F,0xFF,0xFF    ; B7FH
.db 0xF3,0x89,0x83,0x89,0x89,0x89,0x89,0xF9,0x83,0x83,0x83,0xC3,0xC3,0xC3,0x39,0x39    ; B8FH
.db 0x01,0x88,0x31,0x83,0x83,0x83,0x89,0x89,0x81,0x83,0x83,0xE7,0x03,0xE7,0x0C,0xE7    ; B9FH
.db 0x89,0xC3,0x83,0x89,0x99,0x39,0xFF,0xFF,0x83,0xFF,0xFF,0xF9,0xC1,0xE7,0xFF,0xFF    ; BAFH
.db 0xBB,0x55,0x88,0xE7,0xE7,0xE7,0xC9,0xC9,0xE7,0xC9,0xC9,0xC9,0xFF,0xFF,0xFF,0xE7    ; BBFH
.db 0xFF,0xFF,0xE7,0xE7,0xFF,0xE7,0xE7,0xC9,0xFF,0xC9,0xFF,0xC9,0xC9,0xFF,0xC9,0xFF    ; BCFH
.db 0xFF,0xE7,0xC9,0xFF,0xFF,0xE7,0xC9,0xC9,0xE7,0xFF,0xE7,0x00,0x00,0x0F,0xF0,0xFF    ; BDFH
.db 0x89,0x33,0x3F,0x93,0x01,0x8F,0x9F,0xE7,0x81,0xC7,0x11,0xC3,0xFF,0x3F,0xE3,0x39    ; BEFH
.db 0xFF,0x00,0x81,0x81,0xE7,0x8F,0xFF,0xFF,0xFF,0xFF,0xFF,0xE3,0xFF,0xFF,0xFF,0xFF    ; BFFH
 
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0xFF,0x00,0xFF,0xFF,0xFF,0x3F,0xFF    ; C0FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0x83,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; C1FH
.db 0xFF,0xFF,0xFF,0xFF,0xE7,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xCF,0xFF,0xFF,0xFF    ; C2FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; C3FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; C4FH
.db 0xFF,0xF3,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; C5FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xF3,0xFF,0xFF,0x99,0xFF,0xFF,0xFF,0xFF,0xFF    ; C6FH
.db 0x9F,0xF3,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; C7FH
.db 0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xC3,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; C8FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xF9,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x27    ; C9FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xF3,0xF9,0xFF,0xFF,0xFF    ; CAFH
.db 0xEE,0xAA,0x22,0xE7,0xE7,0xE7,0xC9,0xC9,0xE7,0xC9,0xC9,0xC9,0xFF,0xFF,0xFF,0xE7    ; CBFH
.db 0xFF,0xFF,0xE7,0xE7,0xFF,0xE7,0xE7,0xC9,0xFF,0xC9,0xFF,0xC9,0xC9,0xFF,0xC9,0xFF    ; CCFH
.db 0xFF,0xE7,0xC9,0xFF,0xFF,0xE7,0xC9,0xC9,0xE7,0xFF,0xE7,0x00,0x00,0x0F,0xF0,0xFF    ; CDFH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x3F,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; CEFH
.db 0xFF,0xFF,0xFF,0xFF,0xE7,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; CFFH
 
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0xFF,0x00,0xFF,0xFF,0xFF,0xFF,0xFF    ; D0FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; D1FH
.db 0xFF,0xFF,0xFF,0xFF,0xE7,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; D2FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; D3FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; D4FH
.db 0xFF,0xF1,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00    ; D5FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x33,0xFF,0xFF,0x99,0xFF,0xFF,0xFF,0xFF,0xFF    ; D6FH
.db 0x9F,0xF3,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xF3,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; D7FH
.db 0x83,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; D8FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xF3,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x8F    ; D9FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xE0,0xF9,0xFF,0xFF,0xFF    ; DAFH
.db 0xBB,0x55,0x88,0xE7,0xE7,0xE7,0xC9,0xC9,0xE7,0xC9,0xC9,0xC9,0xFF,0xFF,0xFF,0xE7    ; DBFH
.db 0xFF,0xFF,0xE7,0xE7,0xFF,0xE7,0xE7,0xC9,0xFF,0xC9,0xFF,0xC9,0xC9,0xFF,0xC9,0xFF    ; DCFH
.db 0xFF,0xE7,0xC9,0xFF,0xFF,0xE7,0xC9,0xC9,0xE7,0xFF,0xE7,0x00,0x00,0x0F,0xF0,0xFF    ; DDFH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; DEFH
.db 0xFF,0xFF,0xFF,0xFF,0xE7,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; DFFH
 
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0xFF,0x00,0xFF,0xFF,0xFF,0xFF,0xFF    ; E0FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; E1FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; E2FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; E3FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; E4FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; E5FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x87,0xFF,0xFF,0xC3,0xFF,0xFF,0xFF,0xFF,0xFF    ; E6FH
.db 0x0F,0xE1,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x07,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; E7FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; E8FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x87,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; E9FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; EAFH
.db 0xEE,0xAA,0x22,0xE7,0xE7,0xE7,0xC9,0xC9,0xE7,0xC9,0xC9,0xC9,0xFF,0xFF,0xFF,0xE7    ; EBFH
.db 0xFF,0xFF,0xE7,0xE7,0xFF,0xE7,0xE7,0xC9,0xFF,0xC9,0xFF,0xC9,0xC9,0xFF,0xC9,0xFF    ; ECFH
.db 0xFF,0xE7,0xC9,0xFF,0xFF,0xE7,0xC9,0xC9,0xE7,0xFF,0xE7,0x00,0x00,0x0F,0xF0,0xFF    ; EDFH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; EEFH
.db 0xFF,0xFF,0xFF,0xFF,0xE7,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; EFFH
 
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0x00,0xFF,0x00,0xFF,0xFF,0xFF,0xFF,0xFF    ; F0FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; F1FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; F2FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; F3FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; F4FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; F5FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; F6FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; F7FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; F8FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; F9FH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; FAFH
.db 0xBB,0x55,0x88,0xE7,0xE7,0xE7,0xC9,0xC9,0xE7,0xC9,0xC9,0xC9,0xFF,0xFF,0xFF,0xE7    ; FBFH
.db 0xFF,0xFF,0xE7,0xE7,0xFF,0xE7,0xE7,0xC9,0xFF,0xC9,0xFF,0xC9,0xC9,0xFF,0xC9,0xFF    ; FCFH
.db 0xFF,0xE7,0xC9,0xFF,0xFF,0xE7,0xC9,0xC9,0xE7,0xFF,0xE7,0x00,0x00,0x0F,0xF0,0xFF    ; FDFH
.db 0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; FEFH
.db 0xFF,0xFF,0xFF,0xFF,0xE7,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF,0xFF    ; FFFH
 
 
 
 
; *** Unterprogramm Bibliothek ***
; Division von 2 16-Bit Zahlen (WORD)
; Quelle: Mikrocomputertechnik mit Controllern der Atmel AVR-RISC-Familie
;         Guenter Schmitt, ISBN 978-3-486-58988-7
; Version 1.0, Stand 24.01.2013
;
; Uebergabe: R16 Divident Low
;            R17 Divident High
;            R18 Divisor Low
;            R19 Divisor High
; Ergebnis:  R16 Quotient Low
;            R17 Quotient High
;            R18 Rest Low 
;            R19 Rest High 
; Temporaere Register: R20,R21,R22


ASM_UP_MDIV16:

        LDI        R20, 16   ; 16 Schritte 

        MOV        R21, R18  ; R21 = Divisor Low
        MOV        R22, R19  ; R22 = Divisor High

        CLR        R18       ; R18 = Rest Low loeschen
        CLR        R19       ; R19 = Rest High loeschen
ASM_UP_MDIV16a:
			      
        LSL        R16       ; Divident Low links Quotient links Bit_0 <- 0   
        ROL        R17       ; Divident High
        ROL        R18       ; Rest Low
        ROL        R19       ; Rest High

        CP         R18, R21  ; Test Rest Low - Divisor Low
        CPC        R19, R22  ; Test Rest High - Divisor High

        BRLO       ASM_UP_MDIV16b   ; Rest < Divisor : Quotient Bit_0 bleibt 0

        SUB        R18, R21  ; Rest Low >= Divisor Low abziehen
        SBC        R19, R22  ; Rest High >= Divisor High abziehen

        INC        R16       ; Quotient Bit_0 wird 1
ASM_UP_MDIV16b:

        DEC        R20       ; Zaehler - 1
        BRNE       ASM_UP_MDIV16a   ; wiederhole 16 mal



        RET






; Multiplikation von 2 16-Bit Zahlen (WORD)
; Quelle: Mikrocomputertechnik mit Controllern der Atmel AVR-RISC-Familie
;         Guenter Schmitt, ISBN 978-3-486-58988-7
; Version 1.0, Stand 11.01.2013
;
; Uebergabe: R16:R17 erster Faktor
;            R18:R19 zweiter Faktor
; Temporaere Register: R20,R21,R22,R23,R24 
;                      R2 ,R3  R4  R5  R6
ASM_UP_MUL16:
 
        PUSH       R0
        PUSH       R1

        CLR        R24
        MUL        R19, R17
        MOVW       R23:R22, R1:R0
        MUL        R18, R16
        MOVW       R21:R20, R1:R0
        MUL        R19, R16
        ADD        R21, R0
        ADC        R22, R1
        ADC        R23, R24
        MUL        R17, R18
        ADD        R21, R0
        ADC        R22, R1
        ADC        R23, R24
        MOVW       R17:R16, R21:R20       ; Produkt Low
        MOVW       R19:R18, R23:R22       ; Produkt High

        POP        R1
        POP        R0		

        RET






 
; *** Namen-Liste ***
;
; UDR0 (V) BYTECONVAR
; UBRR0H (V) BYTECONVAR
; UBRR0L (V) BYTECONVAR
; UCSR0A (V) BYTECONVAR
; UCSR0B (V) BYTECONVAR
; UCSR0C (V) BYTECONVAR
; TWAMR (V) BYTECONVAR
; TWCR (V) BYTECONVAR
; TWDR (V) BYTECONVAR
; TWAR (V) BYTECONVAR
; TWSR (V) BYTECONVAR
; TWBR (V) BYTECONVAR
; ASSR (V) BYTECONVAR
; OCR2B (V) BYTECONVAR
; OCR2A (V) BYTECONVAR
; TCNT2 (V) BYTECONVAR
; TCCR2B (V) BYTECONVAR
; TCCR2A (V) BYTECONVAR
; TIMSK2 (V) BYTECONVAR
; TIMSK1 (V) BYTECONVAR
; TIMSK0 (V) BYTECONVAR
; OCR1BL (V) BYTECONVAR
; OCR1BH (V) BYTECONVAR
; OCR1AH (V) BYTECONVAR
; OCR1AL (V) BYTECONVAR
; ICR1L (V) BYTECONVAR
; ICR1H (V) BYTECONVAR
; TCNT1L (V) BYTECONVAR
; TCNT1H (V) BYTECONVAR
; TCCR1C (V) BYTECONVAR
; TCCR1B (V) BYTECONVAR
; TCCR1A (V) BYTECONVAR
; DIDR1 (V) BYTECONVAR
; DIDR0 (V) BYTECONVAR
; ADMUX (V) BYTECONVAR
; ADCSRB (V) BYTECONVAR
; ADCSRA (V) BYTECONVAR
; ADCH (V) BYTECONVAR
; ADCL (V) BYTECONVAR
; PCMSK0 (V) BYTECONVAR
; PCMSK1 (V) BYTECONVAR
; PCMSK2 (V) BYTECONVAR
; PCMSK3 (V) BYTECONVAR
; EICRA (V) BYTECONVAR
; PCICR (V) BYTECONVAR
; OSCCAL (V) BYTECONVAR
; PRR0 (V) BYTECONVAR
; CLKPR (V) BYTECONVAR
; WDTCSR (V) BYTECONVAR
; SREG (V) BYTECONREG
; SPL (V) BYTECONREG
; SPH (V) BYTECONREG
; SPMCSR (V) BYTECONREG
; MCUCR (V) BYTECONREG
; MCUSR (V) BYTECONREG
; SMCR (V) BYTECONREG
; OCDR (V) BYTECONREG
; ACSR (V) BYTECONREG
; SPDR (V) BYTECONREG
; SPSR (V) BYTECONREG
; SPCR (V) BYTECONREG
; GPIOR0 (V) BYTECONREG
; GPIOR1 (V) BYTECONREG
; GPIOR2 (V) BYTECONREG
; OCR0A (V) BYTECONREG
; OCR0B (V) BYTECONREG
; TCNT0 (V) BYTECONREG
; TCCR0A (V) BYTECONREG
; TCCR0B (V) BYTECONREG
; GTCCR (V) BYTECONREG
; EEARH (V) BYTECONREG
; EEARL (V) BYTECONREG
; EEDR (V) BYTECONREG
; EECR (V) BYTECONREG
; EIMSK (V) BYTECONREG
; EIFR (V) BYTECONREG
; PCIFR (V) BYTECONREG
; TIFR2 (V) BYTECONREG
; TIFR1 (V) BYTECONREG
; TIFR0 (V) BYTECONREG
; PORTA (V) BYTECONREG
; DDRA (V) BYTECONREG
; PINA (V) BYTECONREG
; PORTB (V) BYTECONREG
; DDRB (V) BYTECONREG
; PINB (V) BYTECONREG
; PORTC (V) BYTECONREG
; DDRC (V) BYTECONREG
; PINC (V) BYTECONREG
; PORTD (V) BYTECONREG
; DDRD (V) BYTECONREG
; PIND (V) BYTECONREG
; RXC0 (B) BIT
; TXC0 (B) BIT
; UDRE0 (B) BIT
; CTC_WERT (C) WORD Wert=0x02FA
; LAENGE_BWS (C) WORD Wert=0x07B3
; ANZAHL_SPALTEN (C) WORD Wert=0x0044
; LAENGE_VLINE_ARRAY (C) WORD Wert=0x01FD
; VLINE (A) 
; VSYNC (B) BIT
; HSYNC (B) BIT
; LED_GN (B) BIT
; CE_CLK (B) BIT
; SL (B) BIT
; WERT_YL (V) BYTE
; WERT_YH (V) BYTE
; WERT_ZH (V) BYTE
; WERT_BWS_H (V) BYTE
; WERT_BWS_L (V) BYTE
; FUELLBYTE (V) BYTE
; BWS (Y) BYTE
; BWS_POS (V) WORD
; TIMER0_AUS (P) 
; INIT_TIMER0_OVF (P) 
; TIMER1_AUS (P) 
; INIT_TIMER1_COMPA (P) 
; INIT_TIMER1_OVF (P) 
; INIT_TIMER2_OVF (P) 
; INITPORTS (P) 
; WRITE_STRING (V) STRING
; ESC_SEQUENZ_FOLGT (V) BOOLEAN
; CURSOR_IS_ON (V) BOOLEAN
; CURSOR_BYTE (V) BYTE
; CURSOR_COUNTER (V) WORD
; SWITCH_CURSOR_ON (P) 
; SWITCH_CURSOR_OFF (P) 
; SWITCH_CURSOR (P) 
; SCHREIBE_ZEICHEN_IN_BWS (P) 
; SCREEN_ROLL_UP (P) 
; BERECHNE_LF (P) 
; LOESCHE_BWS (P) 
; BERECHNE_CR (P) 
; SCHREIBE_BYTE_IN_BWS (P) 
; FUELLE_BWS_MIT_ZEICHEN (P) 
; WRITE (P) 
; WRITELN (P) 
; INIT_CONOUT (P) 
; D0_A (B) BIT
; D1_A (B) BIT
; D2_A (B) BIT
; D3_A (B) BIT
; DR_A (B) BIT
; D0_D (B) BIT
; D1_D (B) BIT
; D2_D (B) BIT
; D3_D (B) BIT
; DR_D (B) BIT
; D0_E (B) BIT
; D1_E (B) BIT
; D2_E (B) BIT
; D3_E (B) BIT
; DR_E (B) BIT
; DS_A (B) BIT
; DS_D (B) BIT
; DS_E (B) BIT
; ITP3_WHO_AM_I (C) BYTE Wert=0x01
; ITP3_ERROR_CODE (C) BYTE Wert=0x02
; ITP3_CONOUT (C) BYTE Wert=0x03
; ITP3_CONST (C) BYTE Wert=0x04
; ITP3_CONIN (C) BYTE Wert=0x05
; ITP3_CLIENT_INIT (P) 
; ITP3_HALBBYTE_EINLESEN (F) 
; ITP3_BYTE_EINLESEN (F) 
; ITP3_HALBBYTE_AUSGEBEN (P) 
; ITP3_BYTE_AUSGEBEN (P) 
; ITP3_PRG_CONOUT (P) 
; ITP3_PRG_WHO_AM_I (P) 
; ITP3_SERVER_ABFRAGE (P) 
 
; *** Prozedur/Function-Liste ***
;
; PROCEDURE TIMER0_AUS;
; PROCEDURE INIT_TIMER0_OVF;
; PROCEDURE TIMER1_AUS;
; PROCEDURE INIT_TIMER1_COMPA (WERT : WORD) (B_WERT_L : BYTE) (B_WERT_H : BYTE);
; PROCEDURE INIT_TIMER1_OVF;
; PROCEDURE INIT_TIMER2_OVF;
; PROCEDURE INITPORTS;
; PROCEDURE SWITCH_CURSOR_ON;
; PROCEDURE SWITCH_CURSOR_OFF;
; PROCEDURE SWITCH_CURSOR;
; PROCEDURE SCHREIBE_ZEICHEN_IN_BWS (DAS_BYTE : BYTE);
; PROCEDURE SCREEN_ROLL_UP (W1 : WORD) (W2 : WORD) (W3 : WORD) (B1 : BYTE);
; PROCEDURE BERECHNE_LF (W1 : WORD);
; PROCEDURE LOESCHE_BWS (ZEICHEN_ZAEHLER : WORD);
; PROCEDURE BERECHNE_CR (W1 : WORD);
; PROCEDURE SCHREIBE_BYTE_IN_BWS (DAS_BYTE : BYTE);
; PROCEDURE FUELLE_BWS_MIT_ZEICHEN (ZEICHEN_ZAEHLER : WORD) (DAS_ZEICHEN : BYTE);
; PROCEDURE WRITE (C1 : CHAR) (LAENGE : BYTE) (B1 : BYTE) (B2 : BYTE);
; PROCEDURE WRITELN;
; PROCEDURE INIT_CONOUT;
; PROCEDURE ITP3_CLIENT_INIT;
; FUNCTION ITP3_HALBBYTE_EINLESEN (B1 : BYTE) : BYTE;
; FUNCTION ITP3_BYTE_EINLESEN (B1 : BYTE) (RESULT_BYTE : BYTE) : BYTE;
; PROCEDURE ITP3_HALBBYTE_AUSGEBEN (H_BYTE : BYTE) (B1 : BYTE);
; PROCEDURE ITP3_BYTE_AUSGEBEN (H_BYTE : BYTE) (B1 : BYTE);
; PROCEDURE ITP3_PRG_CONOUT (DATA_BYTE : BYTE);
; PROCEDURE ITP3_PRG_WHO_AM_I (DATA_BYTE : BYTE);
; PROCEDURE ITP3_SERVER_ABFRAGE (CODE_BYTE : BYTE);
 
; *** Konstanten-ARRAYs ***
;
 
VLINE:
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x04,0x04
.db    0x08,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x02
.db    0x02,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x00,0x00
.db    0x01,0x00
 
; *** ISR-Liste ***
;
; Nummer=2    ORG=INT0addr     ISR=INT0          Bemerkung=External Interrupt Request 0
; Nummer=3    ORG=INT1addr     ISR=INT1          Bemerkung=External Interrupt Request 1
; Nummer=4    ORG=PCI0addr     ISR=PCINT0        Bemerkung=Pin Change Interrupt Request 0
; Nummer=5    ORG=PCI1addr     ISR=PCINT1        Bemerkung=Pin Change Interrupt Request 1
; Nummer=6    ORG=PCI2addr     ISR=PCINT2        Bemerkung=Pin Change Interrupt Request 2
; Nummer=7    ORG=WDTaddr      ISR=WDT           Bemerkung=Watchdog Time-out Interrupt
; Nummer=8    ORG=OC2Aaddr     ISR=TIMER2_COMPA  Bemerkung=Timer/Counter2 Compare Match A
; Nummer=9    ORG=OC2Baddr     ISR=TIMER2_COMPB  Bemerkung=Timer/Counter2 Compare Match B
; Nummer=10   ORG=OVF2addr     ISR=TIMER2_OVF    Bemerkung=Timer/Counter2 Overflow
; Nummer=11   ORG=ICP1addr     ISR=TIMER1_CAPT   Bemerkung=Timer/Counter1 Capture Event
; Nummer=12   ORG=OC1Aaddr     ISR=TIMER1_COMPA  Bemerkung=Timer/Counter1 Compare Match A
; Nummer=13   ORG=OC1Baddr     ISR=TIMER1_COMPB  Bemerkung=Timer/Counter1 Compare Match B
; Nummer=14   ORG=OVF1addr     ISR=TIMER1_OVF    Bemerkung=Timer/Counter1 Overflow
; Nummer=15   ORG=OC0Aaddr     ISR=TIMER0_COMPA  Bemerkung=Timer/Counter0 Compare Match A
; Nummer=16   ORG=OC0Baddr     ISR=TIMER0_COMPB  Bemerkung=Timer/Counter0 Compare Match B
; Nummer=17   ORG=OVF0addr     ISR=TIMER0_OVF    Bemerkung=Timer/Counter0 Overflow
; Nummer=18   ORG=SPIaddr      ISR=SPI_STC       Bemerkung=Serial Transfer Complete
; Nummer=19   ORG=URXCaddr     ISR=USART_RXC     Bemerkung=USART, Rx Complete
; Nummer=20   ORG=UDREaddr     ISR=USART_UDRE    Bemerkung=USART Data Register Empty
; Nummer=21   ORG=UTXCaddr     ISR=USART_TXC     Bemerkung=USART, Tx Complete
; Nummer=22   ORG=ADCCaddr     ISR=ADC_CC        Bemerkung=ADC Conversion Complete
; Nummer=23   ORG=ERDYaddr     ISR=EE_RDY        Bemerkung=EEPROM Ready
; Nummer=24   ORG=ACIaddr      ISR=ANA_COMP      Bemerkung=Analog Comparator
; Nummer=25   ORG=TWIaddr      ISR=TWI           Bemerkung=Two-wire Serial Interface
; Nummer=26   ORG=SPMRaddr     ISR=SPM_RDY       Bemerkung=Store Program Memory Ready
 
